#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_math_mp_xi4.py">
#<verify4xi verification = "10" target = "pool4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py; rlock4xi.py; manager4xi.py; value4xi.py; arrayfunction4xi.py; basemanager4xi.py; baseproxy4xi.py; condition4xi.py"/>
#<note4xi note = "
#  RUN
#     > call t test_math_mp_xi4 > ..\txt\test_math_mp_xi4.txt
#  ANALYZE
#     1) SENSING MATH WITH ORIGINAL MULTIPROCESSING      <-- trace with TEST1 in test_math_mp_xi4.txt 
#     2) SENSING MATH WITH HYBRID MULTIPROCESSING        <-- trace with TEST2 in test_math_mp_xi4.txt  
#     3) SENSING MATH WITH DRAGONIZED MULTIPROCESSING4XI <-- trace with OF TEST4 in test_math_mp_xi4.txt  
#        a) OF TEST4     <-- main
#        b) OF WORKER    <-- worker functions which use worker functions as terget functions for processes
#        c) OF DOER      <-- doer functions which are activated as threads by worker functions
#        d) ack2xxxxxxxx <-- settings to test different parts and logic 
#     Option 3) is active and enhanced by control & command messages, verifications, process control ...
#            1) and 2) to be activated if required  
#"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import string
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import time         
except:
    pass
try:                 # rare ones
    from ctypes import Structure, c_double
    import gc
    import random
    import queue # <--- NOT Queue as in the original example
    import operator          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import multiprocessing
from multiprocessing import Process
from multiprocessing import Queue
from multiprocessing import Pipe
from multiprocessing import Lock
from multiprocessing import Manager
from multiprocessing import Pool
from multiprocessing import current_process
from multiprocessing import freeze_support
from multiprocessing.sharedctypes import Value, Array
from multiprocessing.managers import BaseManager, BaseProxy
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

# -------------------------------------------------------------------------------------------------
# Dragon2Xi imports                              
# -------------------------------------------------------------------------------------------------
from process2xi import Process2Xi
from queue2xi  import Queue2Xi
from pipe2xi import Pipe2Xi
from lock2xi import Lock2Xi
from rlock2xi import RLock2Xi
from manager2xi import Manager2Xi 
from pool2xi import Pool2Xi
from value2xi import Value2Xi
from arrayfunction2xi import ArrayFunction2Xi #<--- note: this must be called (Array2Xi uses the class from managers.py)
from basemanager2xi import BaseManager2Xi
from baseproxy2xi import BaseProxy2Xi
from condition2xi import Condition2Xi  


# -------------------------------------------------------------------------------------------------
# Dragon4Xi imports                              
# -------------------------------------------------------------------------------------------------
from cpu_corecount4xi import cpu_corecount4xi
from current_process4xi import get_name_current_process4xi

from dummyprocess4xi import DummyProcess4Xi

from pipe4xi import Pipe4Xi 
from process4xi import Process4Xi
from print4xi import Print4Xi     

from queue4xi  import Queue4Xi

from time4xi import time4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi    
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

global task_queue
global done_queue

global task_queue2xi
global done_queue2xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

    
# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(STEP 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(STEP 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(STEP 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(STEP 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(STEP 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(STEP 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(STEP 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(STEP 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(STEP 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(STEP 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(STEP 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(STEP 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(STEP 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(STEP 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'ArrayFunction4Xi': 'NACK4TRACE',
        'BaseManager4Xi': 'NACK4TRACE',
        'BaseProxy4Xi': 'NACK4TRACE',
        'Condition4Xi': 'NACK4TRACE',
        'cpu_corecount4xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'PipeConnection4Xi': 'NACK4TRACE',      
        'Pool4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_MainProcess4Xi': 'NACK4TRACE',
        'Value4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'        
        }                             

        
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(STEP 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(STEP 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       


# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):



    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-math4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Maths in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Maths in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-math4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Maths in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Maths in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-math4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Maths in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Maths in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker" usage = "
#   worker function for standard multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def worker(input_queue, output_queue):
        
    for func, args in iter(input_queue.get, 'STOP'):
        
        result = calculate(func, args)
  
        output_queue.put(result)
        
        
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2xi" usage = "
#   worker function for Dragon2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def worker2xi(input_queue, output_queue):
        
    for func, args in iter(input_queue.get, 'STOP'):
        
        result = calculate2xi(func, args)
  
        output_queue.put(result)
        
        
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "doer2nolla4xi" usage = "
#   doer function for worker function 
#"> 
# -------------------------------------------------------------------------------------------------
def doer2nolla4xi(input_queue, output_queue, consumer_channel, publisher_channel):

    # ---------------------------------------------------------------------------------------------
    # (STEP 0/33) - BEGIN - OK
    # ---------------------------------------------------------------------------------------------
    print('~' *33)
    print('(STEP 0A/33) OF DOER2NOLLA4XI - GOT INPUT QUEUE: ', input_queue) 
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    print('(STEP 0B/33) OF DOER2NOLLA4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
 
    print('(STEP 0C/33) OF DOER2NOLLA4XI - GOT CONSUMER_CHANNEL: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    # 
    print('(STEP 0D/33) OF DOER2NOLLA4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
    # 
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) - RECEIVE COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------     
    ack2copy = False
    try:
        message2receive = consumer_channel.recv()
        
        print("(STEP 1A/33) OF DOER2NOLLA4XI - RECEIVED FROM CONSUMER_CHANNEL: ", consumer_channel, " CONTROL MESSAGE: ", message2receive)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C4400>  CONTROL MESSAGE:  <copy4xi>0</copy4xi>
        #    
        ack2copy = True
    except:
        print("(STEP 1Z/33) OF DOER2NOLLA4XI *** FAILED TO RECEIVE FROM CONSUMER_CHANNEL: ", consumer_channel)

    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) - SEND ROGER ACCORDING TO COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------         
    ack2roger = False
    if ack2copy is True:
        try:
            # pick from input message the index
            header2message = "<copy4xi>"
            trailer2message = "</copy4xi>"
            index2header = str.find(message2receive,header2message)
            index2trailer = str.find(message2receive,trailer2message)
            
            message2send = "<roger4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</roger4xi>"
            publisher_channel.send(message2send)
            print("(STEP 2A/33) OF DOER2NOLLA4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
            # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C42E8>  CONTROL MESSAGE:  <roger4xi>0</roger4xi>
             
            ack2roger = True
        except:
            print("(STEP 2Z1/33) OF DOER2NOLLA4XI *** FAILED TO SEND TO PUBLISHER_CHANNEL: ", publisher_channel)
    else:
        print("(STEP 2Z2/33) OF DOER2NOLLA4XI *** SKIPPED SENDING ROGER TO PUBLISHER_CHANNEL - ACK2COPY: ", ack2copy)            
    
    # ----------------------------------------------------------------------------------------------------------------
    # (STEP 3/33) - CALCULATE AND PUT RESULT TO QUEUE UNTIL YOU GET STOP - PROVIDED COMMAND AND CONTROL IS ESTABLISHED 
    # ----------------------------------------------------------------------------------------------------------------     
    print('=' *33)
    print('(STEP 3/33) OF DOER2NOLLA4XI - STARTING TO CALCULATE AND PUT RESULTS TO QUEUE UNTIL STOP IS GOT ', time4xi()) 
    print('=' *33)
    
    result2xi = 0
    ack2result = True                                                # False if calculations not wanted                                                                                        
    if ack2roger is True:                                            
         # -----------------------------------------------------------------------------------------------------------
         # COMMAND & CONTROL IS OK 
         # -----------------------------------------------------------------------------------------------------------         
         if ack2result is False:
             # -------------------------------------------------------------------------------------------------------
             # JUST TESTING COMMAND & CONTROL WITH ZERO RESULT 
             # ------------------------------------------------------------------------------------------------------- 
             print('=' *33)
             print('(STEP 3A/33) OF DOER2NOLLA4XI ** SKIPPED CALCULATIONS - RESULT2XI: ', result2xi)
             # SKIPPED CALCULATIONS - RESULT2XI:  0
             print('=' *33)
             try:
                 output_queue.put(result2xi)
                 print('=' *33)
                 print('(STEP 3B/33) OF DOER2NOLLA4XI - PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 # PUT RESULT2XI:  0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038C4D68>
                  
                 print('=' *33)    
             except:
                 print('(STEP 3Z1/33) OF DOER2NOLLA4XI *** FAILED TO PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 ack2result = False 
                 
         else:
             # -------------------------------------------------------------------------------------------------------
             # CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE       
             # -------------------------------------------------------------------------------------------------------                                                         
             print('(STEP 3C/33) OF DOER2NOLLA4XI - STARTING TO CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE ', time4xi())
             ack2stop = False
             while ack2stop is False:
                list2mission = input_queue.get()
                if list2mission == 'STOP':
                   #
                    print('=' *33)
                    print('(STEP 3D/33) OF DOER2NOLLA4XI - GOT STOP FOR CALCULATIONS: ', list2mission)
                    print('=' *33)
                    # STOP
                    ack2stop = True
                    
                    # ---------------------------------------------------------------------------------------------------
                    # SEND STOP RECEIVED MESSAGE      
                    # ---------------------------------------------------------------------------------------------------                              
                    message2send = "<stop4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</stop4xi>"
                    publisher_channel.send(message2send)
                    print("(STEP 3D/33) OF DOER2NOLLA4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
                    # <stop4xi>0</stop4xi> <-- expected
                else:
                    # ---------------------------------------------------------------------------------------------------
                    # CALCULATION MISSION 
                    # ---------------------------------------------------------------------------------------------------                    
                    print('=' *33)
                    print('(STEP 3E/33) OF DOER2NOLLA4XI - GOT CALCULATION MISSION: ', list2mission)
                    # [(<function multiply at 0x0000000003795488>, (0, 7)),
                    #  (<function multiply at 0x0000000003795488>, (1, 7)),
                    #  (<function multiply at 0x0000000003795488>, (2, 7)) ...
                    # ]
                    # [(<function add at 0x000000000390A7B8>, (0, 8)), (<function add at 0x000000000390A7B8>, (1, 8)) ...
                       
                    print('=' *33)   
                    # -----------------------------------------------------------------------------------------------
                    # MISSION LIST 
                    # -----------------------------------------------------------------------------------------------   
                    for index in range (0, len(list2mission)):
                        try:
                            func = list2mission[index] [0]
                        except:
                            print('(STEP 3Z1/33) OF DOER2NOLLA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:        
                            args = list2mission[index] [1]    
                        except:
                            print('(STEP 3Z2/33) OF DOER2NOLLA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:     
                            print('=' *33)
                            print('(STEP 3F/33) OF DOER2NOLLA4XI - GOT FUNC: ', func)
                            # <function multiply at 0x0000000003904488>
                            # 
                            print('(STEP 3G/33) OF DOER2NOLLA4XI - GOT ARGS: ', args)
                            # (0, 7) ... (4, 7)
                            print('=' *33)
                        except:
                            print('(STEP 3Z3/33) OF DOER2NOLLA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            result2xi = calculate2nolla4xi(func, args)             
                            print('=' *33)
                            print('(STEP 3H/33) OF DOER2NOLLA4XI - CALCULATED RESULT2XI: ', result2xi, ' ACK2RESULT: ', ack2result)
                            print('=' *33)
                            # 0 ... 28        
                        except:
                            print('(STEP 3Z4/33) OF DOER2NOLLA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            output_queue.put(result2xi)
                        
                            print('=' *33)
                            print('(STEP 3I/33) OF DOER2NOLLA4XI - PUT CALCULATION: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue, ' FUNCTION: ', func, ' ARGS: ', args)
                            print('=' *33)
                            # MISSION 1
                            # 0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x000000000395C160>  FUNCTION:  <function multiply at 0x00000000038B6730>  ARGS:  (0, 7)
                            #  ...
                            # 112  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x000000000395C6A0>  FUNCTION:  <function multiply at 0x00000000038B6730>  ARGS:  (16, 7)
                            # 
                            # MISSION 2
                            # 8  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x000000000395C160>  FUNCTION:  <function add at 0x00000000038B67B8>  ARGS:  (0, 8)
                            # ...
                            # 17  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x000000000395C160>  FUNCTION:  <function add at 0x00000000038B67B8>  ARGS:  (9, 8)
                        except:
                            print('(STEP 3Z5/33) OF DOER2NOLLA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                            
                    print('(STEP 3J/33) OF DOER2NOLLA4XI - COMPLETED ONE CALCULATION MISSION AND WAITING MORE ', time4xi())    
                    # 04:24:28 02/27/13 Pacific Standard Time                    
                time.sleep(0.2*random.random())                                                
    else:
        print("(STEP 3Y/33) OF DOER2NOLLA4XI ** YIELDED CALCULATIONS BECAUSE OF FAILED COMMAND AND CONTROL - ACK2ROGER ** ", ack2roger)
        
    print('=' *33)
    print('(STEP 1C/33) OF DOER2NOLLA4XI - RETURNING ', time4xi())
    # 05:17:30 02/26/13 Pacific Standard Time
    print('=' *33)   
#</function4xi>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "doer2yksi4xi" usage = "
#   doer function for worker function 
#"> 
# -------------------------------------------------------------------------------------------------
def doer2yksi4xi(input_queue, output_queue, consumer_channel, publisher_channel):

    # ---------------------------------------------------------------------------------------------
    # (STEP 0/33) - BEGIN - OK
    # ---------------------------------------------------------------------------------------------
    print('~' *33)
    print('(STEP 0A/33) OF DOER2YKSI4XI - GOT INPUT QUEUE: ', input_queue) 
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    print('(STEP 0B/33) OF DOER2YKSI4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
 
    print('(STEP 0C/33) OF DOER2YKSI4XI - GOT CONSUMER_CHANNEL: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    # 
    print('(STEP 0D/33) OF DOER2YKSI4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
    # 
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) - RECEIVE COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------     
    ack2copy = False
    try:
        message2receive = consumer_channel.recv()
        
        print("(STEP 1A/33) OF DOER2YKSI4XI - RECEIVED FROM CONSUMER_CHANNEL: ", consumer_channel, " CONTROL MESSAGE: ", message2receive)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C4400>  CONTROL MESSAGE:  <copy4xi>0</copy4xi>
        #    
        ack2copy = True
    except:
        print("(STEP 1Z/33) OF DOER2YKSI4XI *** FAILED TO RECEIVE FROM CONSUMER_CHANNEL: ", consumer_channel)

    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) - SEND ROGER ACCORDING TO COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------         
    ack2roger = False
    if ack2copy is True:
        try:
            # pick from input message the index
            header2message = "<copy4xi>"
            trailer2message = "</copy4xi>"
            index2header = str.find(message2receive,header2message)
            index2trailer = str.find(message2receive,trailer2message)
            
            message2send = "<roger4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</roger4xi>"
            publisher_channel.send(message2send)
            print("(STEP 2A/33) OF DOER2YKSI4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
            # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C42E8>  CONTROL MESSAGE:  <roger4xi>0</roger4xi>
             
            ack2roger = True
        except:
            print("(STEP 2Z1/33) OF DOER2YKSI4XI *** FAILED TO SEND TO PUBLISHER_CHANNEL: ", publisher_channel)
    else:
        print("(STEP 2Z2/33) OF DOER2YKSI4XI *** SKIPPED SENDING ROGER TO PUBLISHER_CHANNEL - ACK2COPY: ", ack2copy)            
    
    # ----------------------------------------------------------------------------------------------------------------
    # (STEP 3/33) - CALCULATE AND PUT RESULT TO QUEUE UNTIL YOU GET STOP - PROVIDED COMMAND AND CONTROL IS ESTABLISHED 
    # ----------------------------------------------------------------------------------------------------------------     
    print('=' *33)
    print('(STEP 3/33) OF DOER2YKSI4XI - STARTING TO CALCULATE AND PUT RESULTS TO QUEUE UNTIL STOP IS GOT ', time4xi()) 
    print('=' *33)
    
    result2xi = 0
    ack2result = True                                                # False if calculations not wanted                                                                                        
    if ack2roger is True:                                            
         # -----------------------------------------------------------------------------------------------------------
         # COMMAND & CONTROL IS OK 
         # -----------------------------------------------------------------------------------------------------------         
         if ack2result is False:
             # -------------------------------------------------------------------------------------------------------
             # JUST TESTING COMMAND & CONTROL WITH ZERO RESULT 
             # ------------------------------------------------------------------------------------------------------- 
             print('=' *33)
             print('(STEP 3A/33) OF DOER2YKSI4XI ** SKIPPED CALCULATIONS - RESULT2XI: ', result2xi)
             # SKIPPED CALCULATIONS - RESULT2XI:  0
             print('=' *33)
             try:
                 output_queue.put(result2xi)
                 print('=' *33)
                 print('(STEP 3B/33) OF DOER2YKSI4XI - PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 # PUT RESULT2XI:  0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038C4D68>
                  
                 print('=' *33)    
             except:
                 print('(STEP 3Z1/33) OF DOER2YKSI4XI *** FAILED TO PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 ack2result = False 
                 
         else:
             # -------------------------------------------------------------------------------------------------------
             # CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE       
             # -------------------------------------------------------------------------------------------------------                                                         
             print('(STEP 3C/33) OF DOER2YKSI4XI - STARTING TO CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE ', time4xi())
             ack2stop = False
             while ack2stop is False:
                list2mission = input_queue.get()
                if list2mission == 'STOP':
                   #
                    print('=' *33)
                    print('(STEP 3D/33) OF DOER2YKSI4XI - GOT STOP FOR CALCULATIONS: ', list2mission)
                    print('=' *33)
                    # STOP
                    ack2stop = True
                                        
                    # ---------------------------------------------------------------------------------------------------
                    # SEND STOP RECEIVED MESSAGE      
                    # ---------------------------------------------------------------------------------------------------                              
                    message2send = "<stop4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</stop4xi>"
                    publisher_channel.send(message2send)
                    print("(STEP 3D/33) OF DOER2YKSI4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
                    # <stop4xi>0</stop4xi> <-- expected
                else:
                    # ---------------------------------------------------------------------------------------------------
                    # CALCULATION MISSION 
                    # ---------------------------------------------------------------------------------------------------                    
                    print('=' *33)
                    print('(STEP 3E/33) OF DOER2YKSI4XI - GOT CALCULATION MISSION: ', list2mission)
                    # [(<function multiply at 0x0000000003795488>, (0, 7)),
                    #  (<function multiply at 0x0000000003795488>, (1, 7)),
                    #  (<function multiply at 0x0000000003795488>, (2, 7)) ...
                    # ] 
                    # [(<function add at 0x000000000390A7B8>, (0, 8)), (<function add at 0x000000000390A7B8>, (1, 8)) ...  
                    print('=' *33)   
                    # -----------------------------------------------------------------------------------------------
                    # MISSION LIST 
                    # -----------------------------------------------------------------------------------------------   
                    for index in range (0, len(list2mission)):
                        try:
                            func = list2mission[index] [0]
                        except:
                            print('(STEP 3Z1/33) OF DOER2YKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:        
                            args = list2mission[index] [1]    
                        except:
                            print('(STEP 3Z2/33) OF DOER2YKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:     
                            print('=' *33)
                            print('(STEP 3F/33) OF DOER2YKSI4XI - GOT FUNC: ', func)
                            # <function multiply at 0x0000000003904488>
                            # 
                            print('(STEP 3G/33) OF DOER2YKSI4XI - GOT ARGS: ', args)
                            # (0, 7) ... (4, 7)
                            print('=' *33)
                        except:
                            print('(STEP 3Z3/33) OF DOER2YKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            result2xi = calculate2yksi4xi(func, args)             
                            print('=' *33)
                            print('(STEP 3H/33) OF DOER2YKSI4XI - CALCULATED RESULT2XI: ', result2xi, ' ACK2RESULT: ', ack2result)
                            print('=' *33)
                            # 0 ... 28        
                        except:
                            print('(STEP 3Z4/33) OF DOER2YKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            output_queue.put(result2xi)
                        
                            print('=' *33)
                            print('(STEP 3I/33) OF DOER2YKSI4XI - PUT CALCULATION: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue, ' FUNCTION: ', func, ' ARGS: ', args)
                            print('=' *33)
                            # 0   TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98>
                            # 28  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98> ...    
                        except:
                            print('(STEP 3Z5/33) OF DOER2YKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                            
                    print('(STEP 3J/33) OF DOER2YKSI4XI - COMPLETED ONE CALCULATION MISSION AND WAITING MORE ', time4xi())    
                    # 04:24:28 02/27/13 Pacific Standard Time                    
                time.sleep(0.2*random.random())                                                
    else:
        print("(STEP 3Y/33) OF DOER2YKSI4XI ** YIELDED CALCULATIONS BECAUSE OF FAILED COMMAND AND CONTROL - ACK2ROGER ** ", ack2roger)
        
    print('=' *33)
    print('(STEP 1C/33) OF DOER2YKSI4XI - RETURNING ', time4xi())
    # 05:17:30 02/26/13 Pacific Standard Time
    print('=' *33)   
#</function4xi>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "doer2kaksi4xi" usage = "
#   doer function for worker function 
#"> 
# -------------------------------------------------------------------------------------------------
def doer2kaksi4xi(input_queue, output_queue, consumer_channel, publisher_channel):

    # ---------------------------------------------------------------------------------------------
    # (STEP 0/33) - BEGIN - OK
    # ---------------------------------------------------------------------------------------------
    print('~' *33)
    print('(STEP 0A/33) OF DOER2KAKSI4XI - GOT INPUT QUEUE: ', input_queue) 
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    print('(STEP 0B/33) OF DOER2KAKSI4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
 
    print('(STEP 0C/33) OF DOER2KAKSI4XI - GOT CONSUMER_CHANNEL: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    # 
    print('(STEP 0D/33) OF DOER2KAKSI4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
    # 
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) - RECEIVE COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------     
    ack2copy = False
    try:
        message2receive = consumer_channel.recv()
        
        print("(STEP 1A/33) OF DOER2KAKSI4XI - RECEIVED FROM CONSUMER_CHANNEL: ", consumer_channel, " CONTROL MESSAGE: ", message2receive)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C4400>  CONTROL MESSAGE:  <copy4xi>0</copy4xi>
        #    
        ack2copy = True
    except:
        print("(STEP 1Z/33) OF DOER2KAKSI4XI *** FAILED TO RECEIVE FROM CONSUMER_CHANNEL: ", consumer_channel)

    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) - SEND ROGER ACCORDING TO COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------         
    ack2roger = False
    if ack2copy is True:
        try:
            # pick from input message the index
            header2message = "<copy4xi>"
            trailer2message = "</copy4xi>"
            index2header = str.find(message2receive,header2message)
            index2trailer = str.find(message2receive,trailer2message)
            
            message2send = "<roger4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</roger4xi>"
            publisher_channel.send(message2send)
            print("(STEP 2A/33) OF DOER2KAKSI4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
            # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C42E8>  CONTROL MESSAGE:  <roger4xi>0</roger4xi>
             
            ack2roger = True
        except:
            print("(STEP 2Z1/33) OF DOER2KAKSI4XI *** FAILED TO SEND TO PUBLISHER_CHANNEL: ", publisher_channel)
    else:
        print("(STEP 2Z2/33) OF DOER2KAKSI4XI *** SKIPPED SENDING ROGER TO PUBLISHER_CHANNEL - ACK2COPY: ", ack2copy)            
    
    # ----------------------------------------------------------------------------------------------------------------
    # (STEP 3/33) - CALCULATE AND PUT RESULT TO QUEUE UNTIL YOU GET STOP - PROVIDED COMMAND AND CONTROL IS ESTABLISHED 
    # ----------------------------------------------------------------------------------------------------------------     
    print('=' *33)
    print('(STEP 3/33) OF DOER2KAKSI4XI - STARTING TO CALCULATE AND PUT RESULTS TO QUEUE UNTIL STOP IS GOT ', time4xi()) 
    print('=' *33)
    
    result2xi = 0
    ack2result = True                                                # False if calculations not wanted                                                                                        
    if ack2roger is True:                                            
         # -----------------------------------------------------------------------------------------------------------
         # COMMAND & CONTROL IS OK 
         # -----------------------------------------------------------------------------------------------------------         
         if ack2result is False:
             # -------------------------------------------------------------------------------------------------------
             # JUST TESTING COMMAND & CONTROL WITH ZERO RESULT 
             # ------------------------------------------------------------------------------------------------------- 
             print('=' *33)
             print('(STEP 3A/33) OF DOER2KAKSI4XI ** SKIPPED CALCULATIONS - RESULT2XI: ', result2xi)
             # SKIPPED CALCULATIONS - RESULT2XI:  0
             print('=' *33)
             try:
                 output_queue.put(result2xi)
                 print('=' *33)
                 print('(STEP 3B/33) OF DOER2KAKSI4XI - PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 # PUT RESULT2XI:  0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038C4D68>
                  
                 print('=' *33)    
             except:
                 print('(STEP 3Z1/33) OF DOER2KAKSI4XI *** FAILED TO PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 ack2result = False 
                 
         else:
             # -------------------------------------------------------------------------------------------------------
             # CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE       
             # -------------------------------------------------------------------------------------------------------                                                         
             print('(STEP 3C/33) OF DOER2KAKSI4XI - STARTING TO CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE ', time4xi())
             ack2stop = False
             while ack2stop is False:
                list2mission = input_queue.get()
                if list2mission == 'STOP':
                   #
                    print('=' *33)
                    print('(STEP 3D/33) OF DOER2KAKSI4XI - GOT STOP FOR CALCULATIONS: ', list2mission)
                    print('=' *33)
                    # STOP
                    ack2stop = True
                                        
                    # ---------------------------------------------------------------------------------------------------
                    # SEND STOP RECEIVED MESSAGE      
                    # ---------------------------------------------------------------------------------------------------                              
                    message2send = "<stop4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</stop4xi>"
                    publisher_channel.send(message2send)
                    print("(STEP 3D/33) OF DOER2KAKSI4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
                    # <stop4xi>0</stop4xi> <-- expected
                else:
                    # ---------------------------------------------------------------------------------------------------
                    # CALCULATION MISSION 
                    # ---------------------------------------------------------------------------------------------------                    
                    print('=' *33)
                    print('(STEP 3E/33) OF DOER2KAKSI4XI - GOT CALCULATION MISSION: ', list2mission)
                    # [(<function multiply at 0x0000000003795488>, (0, 7)),
                    #  (<function multiply at 0x0000000003795488>, (1, 7)),
                    #  (<function multiply at 0x0000000003795488>, (2, 7)) ...
                    # ]
                    # [(<function add at 0x000000000390A7B8>, (0, 8)), (<function add at 0x000000000390A7B8>, (1, 8)) ...   
                    print('=' *33)   
                    # -----------------------------------------------------------------------------------------------
                    # MISSION LIST 
                    # -----------------------------------------------------------------------------------------------   
                    for index in range (0, len(list2mission)):
                        try:
                            func = list2mission[index] [0]
                        except:
                            print('(STEP 3Z1/33) OF DOER2KAKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:        
                            args = list2mission[index] [1]    
                        except:
                            print('(STEP 3Z2/33) OF DOER2KAKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:     
                            print('=' *33)
                            print('(STEP 3F/33) OF DOER2KAKSI4XI - GOT FUNC: ', func)
                            # <function multiply at 0x0000000003904488>
                            # 
                            print('(STEP 3G/33) OF DOER2KAKSI4XI - GOT ARGS: ', args)
                            # (0, 7) ... (4, 7)
                            print('=' *33)
                        except:
                            print('(STEP 3Z3/33) OF DOER2KAKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            result2xi = calculate2kaksi4xi(func, args)             
                            print('=' *33)
                            print('(STEP 3H/33) OF DOER2KAKSI4XI - CALCULATED RESULT2XI: ', result2xi, ' ACK2RESULT: ', ack2result)
                            print('=' *33)
                            # 0 ... 28        
                        except:
                            print('(STEP 3Z4/33) OF DOER2KAKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            output_queue.put(result2xi)
                        
                            print('=' *33)
                            print('(STEP 3I/33) OF DOER2KAKSI4XI - PUT CALCULATION: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue, ' FUNCTION: ', func, ' ARGS: ', args)
                            print('=' *33)
                            # 0   TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98>
                            # 28  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98> ...    
                        except:
                            print('(STEP 3Z5/33) OF DOER2KAKSI4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                            
                    print('(STEP 3J/33) OF DOER2KAKSI4XI - COMPLETED ONE CALCULATION MISSION AND WAITING MORE ', time4xi())    
                    # 04:24:28 02/27/13 Pacific Standard Time                    
                time.sleep(0.2*random.random())                                                
    else:
        print("(STEP 3Y/33) OF DOER2KAKSI4XI ** YIELDED CALCULATIONS BECAUSE OF FAILED COMMAND AND CONTROL - ACK2ROGER ** ", ack2roger)
        
    print('=' *33)
    print('(STEP 1C/33) OF DOER2KAKSI4XI - RETURNING ', time4xi())
    # 05:17:30 02/26/13 Pacific Standard Time
    print('=' *33)   
#</function4xi>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "doer2kolme4xi" usage = "
#   doer function for worker function 
#"> 
# -------------------------------------------------------------------------------------------------
def doer2kolme4xi(input_queue, output_queue, consumer_channel, publisher_channel):

    # ---------------------------------------------------------------------------------------------
    # (STEP 0/33) - BEGIN - OK
    # ---------------------------------------------------------------------------------------------
    print('~' *33)
    print('(STEP 0A/33) OF DOER2KOLME4XI - GOT INPUT QUEUE: ', input_queue) 
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    print('(STEP 0B/33) OF DOER2KOLME4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
 
    print('(STEP 0C/33) OF DOER2KOLME4XI - GOT CONSUMER_CHANNEL: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    # 
    print('(STEP 0D/33) OF DOER2KOLME4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
    # 
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) - RECEIVE COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------     
    ack2copy = False
    try:
        message2receive = consumer_channel.recv()
        
        print("(STEP 1A/33) OF DOER2KOLME4XI - RECEIVED FROM CONSUMER_CHANNEL: ", consumer_channel, " CONTROL MESSAGE: ", message2receive)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C4400>  CONTROL MESSAGE:  <copy4xi>0</copy4xi>
        #    
        ack2copy = True
    except:
        print("(STEP 1Z/33) OF DOER2KOLME4XI *** FAILED TO RECEIVE FROM CONSUMER_CHANNEL: ", consumer_channel)

    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) - SEND ROGER ACCORDING TO COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------         
    ack2roger = False
    if ack2copy is True:
        try:
            # pick from input message the index
            header2message = "<copy4xi>"
            trailer2message = "</copy4xi>"
            index2header = str.find(message2receive,header2message)
            index2trailer = str.find(message2receive,trailer2message)
            
            message2send = "<roger4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</roger4xi>"
            publisher_channel.send(message2send)
            print("(STEP 2A/33) OF DOER2KOLME4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
            # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C42E8>  CONTROL MESSAGE:  <roger4xi>0</roger4xi>
             
            ack2roger = True
        except:
            print("(STEP 2Z1/33) OF DOER2KOLME4XI *** FAILED TO SEND TO PUBLISHER_CHANNEL: ", publisher_channel)
    else:
        print("(STEP 2Z2/33) OF DOER2KOLME4XI *** SKIPPED SENDING ROGER TO PUBLISHER_CHANNEL - ACK2COPY: ", ack2copy)            
    
    # ----------------------------------------------------------------------------------------------------------------
    # (STEP 3/33) - CALCULATE AND PUT RESULT TO QUEUE UNTIL YOU GET STOP - PROVIDED COMMAND AND CONTROL IS ESTABLISHED 
    # ----------------------------------------------------------------------------------------------------------------     
    print('=' *33)
    print('(STEP 3/33) OF DOER2KOLME4XI - STARTING TO CALCULATE AND PUT RESULTS TO QUEUE UNTIL STOP IS GOT ', time4xi()) 
    print('=' *33)
    
    result2xi = 0
    ack2result = True                                                # False if calculations not wanted                                                                                        
    if ack2roger is True:                                            
         # -----------------------------------------------------------------------------------------------------------
         # COMMAND & CONTROL IS OK 
         # -----------------------------------------------------------------------------------------------------------         
         if ack2result is False:
             # -------------------------------------------------------------------------------------------------------
             # JUST TESTING COMMAND & CONTROL WITH ZERO RESULT 
             # ------------------------------------------------------------------------------------------------------- 
             print('=' *33)
             print('(STEP 3A/33) OF DOER2KOLME4XI ** SKIPPED CALCULATIONS - RESULT2XI: ', result2xi)
             # SKIPPED CALCULATIONS - RESULT2XI:  0
             print('=' *33)
             try:
                 output_queue.put(result2xi)
                 print('=' *33)
                 print('(STEP 3B/33) OF DOER2KOLME4XI - PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 # PUT RESULT2XI:  0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038C4D68>
                  
                 print('=' *33)    
             except:
                 print('(STEP 3Z1/33) OF DOER2KOLME4XI *** FAILED TO PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 ack2result = False 
                 
         else:
             # -------------------------------------------------------------------------------------------------------
             # CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE       
             # -------------------------------------------------------------------------------------------------------                                                         
             print('(STEP 3C/33) OF DOER2KOLME4XI - STARTING TO CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE ', time4xi())
             ack2stop = False
             while ack2stop is False:
                list2mission = input_queue.get()
                if list2mission == 'STOP':
                   #
                    print('=' *33)
                    print('(STEP 3D/33) OF DOER2KOLME4XI - GOT STOP FOR CALCULATIONS: ', list2mission)
                    print('=' *33)
                    # STOP
                    ack2stop = True
                                        
                    # ---------------------------------------------------------------------------------------------------
                    # SEND STOP RECEIVED MESSAGE      
                    # ---------------------------------------------------------------------------------------------------                              
                    message2send = "<stop4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</stop4xi>"
                    publisher_channel.send(message2send)
                    print("(STEP 3D/33) OF DOER2KOLME4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
                    # <stop4xi>0</stop4xi> <-- expected
                else:
                    # ---------------------------------------------------------------------------------------------------
                    # CALCULATION MISSION 
                    # ---------------------------------------------------------------------------------------------------                    
                    print('=' *33)
                    print('(STEP 3E/33) OF DOER2KOLME4XI - GOT CALCULATION MISSION: ', list2mission)
                    # [(<function multiply at 0x0000000003795488>, (0, 7)),
                    #  (<function multiply at 0x0000000003795488>, (1, 7)),
                    #  (<function multiply at 0x0000000003795488>, (2, 7)) ...
                    # ] 
                    # [(<function add at 0x000000000390A7B8>, (0, 8)), (<function add at 0x000000000390A7B8>, (1, 8)) ...  
                    print('=' *33)   
                    # -----------------------------------------------------------------------------------------------
                    # MISSION LIST 
                    # -----------------------------------------------------------------------------------------------   
                    for index in range (0, len(list2mission)):
                        try:
                            func = list2mission[index] [0]
                        except:
                            print('(STEP 3Z1/33) OF DOER2KOLME4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:        
                            args = list2mission[index] [1]    
                        except:
                            print('(STEP 3Z2/33) OF DOER2KOLME4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:     
                            print('=' *33)
                            print('(STEP 3F/33) OF DOER2KOLME4XI - GOT FUNC: ', func)
                            # <function multiply at 0x0000000003904488>
                            # 
                            print('(STEP 3G/33) OF DOER2KOLME4XI - GOT ARGS: ', args)
                            # (0, 7) ... (4, 7)
                            print('=' *33)
                        except:
                            print('(STEP 3Z3/33) OF DOER2KOLME4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            result2xi = calculate2kolme4xi(func, args)             
                            print('=' *33)
                            print('(STEP 3H/33) OF DOER2KOLME4XI - CALCULATED RESULT2XI: ', result2xi, ' ACK2RESULT: ', ack2result)
                            print('=' *33)
                            # 0 ... 28        
                        except:
                            print('(STEP 3Z4/33) OF DOER2KOLME4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            output_queue.put(result2xi)
                        
                            print('=' *33)
                            print('(STEP 3I/33) OF DOER2KOLME4XI - PUT CALCULATION: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue, ' FUNCTION: ', func, ' ARGS: ', args)
                            print('=' *33)
                            # 0   TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98>
                            # 28  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98> ...    
                        except:
                            print('(STEP 3Z5/33) OF DOER2KOLME4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                            
                    print('(STEP 3J/33) OF DOER2KOLME4XI - COMPLETED ONE CALCULATION MISSION AND WAITING MORE ', time4xi())    
                    # 04:24:28 02/27/13 Pacific Standard Time                    
                time.sleep(0.2*random.random())                                                
    else:
        print("(STEP 3Y/33) OF DOER2KOLME4XI ** YIELDED CALCULATIONS BECAUSE OF FAILED COMMAND AND CONTROL - ACK2ROGER ** ", ack2roger)
        
    print('=' *33)
    print('(STEP 1C/33) OF DOER2KOLME4XI - RETURNING ', time4xi())
    # 05:17:30 02/26/13 Pacific Standard Time
    print('=' *33)   
#</function4xi>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "doer2nelja4xi" usage = "
#   doer function for worker function 
#"> 
# -------------------------------------------------------------------------------------------------
def doer2nelja4xi(input_queue, output_queue, consumer_channel, publisher_channel):

    # ---------------------------------------------------------------------------------------------
    # (STEP 0/33) - BEGIN - OK
    # ---------------------------------------------------------------------------------------------
    print('~' *33)
    print('(STEP 0A/33) OF DOER2NELJA4XI - GOT INPUT QUEUE: ', input_queue) 
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    print('(STEP 0B/33) OF DOER2NELJA4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
 
    print('(STEP 0C/33) OF DOER2NELJA4XI - GOT CONSUMER_CHANNEL: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    # 
    print('(STEP 0D/33) OF DOER2NELJA4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
    # 
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) - RECEIVE COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------     
    ack2copy = False
    try:
        message2receive = consumer_channel.recv()
        
        print("(STEP 1A/33) OF DOER2NELJA4XI - RECEIVED FROM CONSUMER_CHANNEL: ", consumer_channel, " CONTROL MESSAGE: ", message2receive)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C4400>  CONTROL MESSAGE:  <copy4xi>0</copy4xi>
        #    
        ack2copy = True
    except:
        print("(STEP 1Z/33) OF DOER2NELJA4XI *** FAILED TO RECEIVE FROM CONSUMER_CHANNEL: ", consumer_channel)

    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) - SEND ROGER ACCORDING TO COPY MESSAGE - OK
    # ---------------------------------------------------------------------------------------------         
    ack2roger = False
    if ack2copy is True:
        try:
            # pick from input message the index
            header2message = "<copy4xi>"
            trailer2message = "</copy4xi>"
            index2header = str.find(message2receive,header2message)
            index2trailer = str.find(message2receive,trailer2message)
            
            message2send = "<roger4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</roger4xi>"
            publisher_channel.send(message2send)
            print("(STEP 2A/33) OF DOER2NELJA4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
            # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C42E8>  CONTROL MESSAGE:  <roger4xi>0</roger4xi>
             
            ack2roger = True
        except:
            print("(STEP 2Z1/33) OF DOER2NELJA4XI *** FAILED TO SEND TO PUBLISHER_CHANNEL: ", publisher_channel)
    else:
        print("(STEP 2Z2/33) OF DOER2NELJA4XI *** SKIPPED SENDING ROGER TO PUBLISHER_CHANNEL - ACK2COPY: ", ack2copy)            
    
    # ----------------------------------------------------------------------------------------------------------------
    # (STEP 3/33) - CALCULATE AND PUT RESULT TO QUEUE UNTIL YOU GET STOP - PROVIDED COMMAND AND CONTROL IS ESTABLISHED 
    # ----------------------------------------------------------------------------------------------------------------     
    print('=' *33)
    print('(STEP 3/33) OF DOER2NELJA4XI - STARTING TO CALCULATE AND PUT RESULTS TO QUEUE UNTIL STOP IS GOT ', time4xi()) 
    print('=' *33)
    
    result2xi = 0
    ack2result = True                                                # False if calculations not wanted                                                                                        
    if ack2roger is True:                                            
         # -----------------------------------------------------------------------------------------------------------
         # COMMAND & CONTROL IS OK 
         # -----------------------------------------------------------------------------------------------------------         
         if ack2result is False:
             # -------------------------------------------------------------------------------------------------------
             # JUST TESTING COMMAND & CONTROL WITH ZERO RESULT 
             # ------------------------------------------------------------------------------------------------------- 
             print('=' *33)
             print('(STEP 3A/33) OF DOER2NELJA4XI ** SKIPPED CALCULATIONS - RESULT2XI: ', result2xi)
             # SKIPPED CALCULATIONS - RESULT2XI:  0
             print('=' *33)
             try:
                 output_queue.put(result2xi)
                 print('=' *33)
                 print('(STEP 3B/33) OF DOER2NELJA4XI - PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 # PUT RESULT2XI:  0  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038C4D68>
                  
                 print('=' *33)    
             except:
                 print('(STEP 3Z1/33) OF DOER2NELJA4XI *** FAILED TO PUT RESULT2XI: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue)
                 ack2result = False 
                 
         else:
             # -------------------------------------------------------------------------------------------------------
             # CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE       
             # -------------------------------------------------------------------------------------------------------                                                         
             print('(STEP 3C/33) OF DOER2NELJA4XI - STARTING TO CALCULATE BY GETTING TASKS FROM QUEUE AND PUTTING RESULTS TO QUEUE ', time4xi())
             ack2stop = False
             while ack2stop is False:
                list2mission = input_queue.get()
                if list2mission == 'STOP':
                   #
                    print('=' *33)
                    print('(STEP 3D/33) OF DOER2NELJA4XI - GOT STOP FOR CALCULATIONS: ', list2mission)
                    print('=' *33)
                    # STOP
                    ack2stop = True
                                        
                    # ---------------------------------------------------------------------------------------------------
                    # SEND STOP RECEIVED MESSAGE      
                    # ---------------------------------------------------------------------------------------------------                              
                    message2send = "<stop4xi>" + str(message2receive[index2header+len(header2message):index2trailer]) + "</stop4xi>"
                    publisher_channel.send(message2send)
                    print("(STEP 3D/33) OF DOER2NELJA4XI - SENT TO PUBLISHER_CHANNEL: ", publisher_channel, " CONTROL MESSAGE: ", message2send)
                    # <stop4xi>0</stop4xi> <-- expected
                else:
                    # ---------------------------------------------------------------------------------------------------
                    # CALCULATION MISSION 
                    # ---------------------------------------------------------------------------------------------------                    
                    print('=' *33)
                    print('(STEP 3E/33) OF DOER2NELJA4XI - GOT CALCULATION MISSION: ', list2mission)
                    # [(<function multiply at 0x0000000003795488>, (0, 7)),
                    #  (<function multiply at 0x0000000003795488>, (1, 7)),
                    #  (<function multiply at 0x0000000003795488>, (2, 7)) ...
                    # ]
                    # [(<function add at 0x000000000390A7B8>, (0, 8)), (<function add at 0x000000000390A7B8>, (1, 8)) ...   
                    print('=' *33)   
                    # -----------------------------------------------------------------------------------------------
                    # MISSION LIST 
                    # -----------------------------------------------------------------------------------------------   
                    for index in range (0, len(list2mission)):
                        try:
                            func = list2mission[index] [0]
                        except:
                            print('(STEP 3Z1/33) OF DOER2NELJA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:        
                            args = list2mission[index] [1]    
                        except:
                            print('(STEP 3Z2/33) OF DOER2NELJA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:     
                            print('=' *33)
                            print('(STEP 3F/33) OF DOER2NELJA4XI - GOT FUNC: ', func)
                            # <function multiply at 0x0000000003904488>
                            # 
                            print('(STEP 3G/33) OF DOER2NELJA4XI - GOT ARGS: ', args)
                            # (0, 7) ... (4, 7)
                            print('=' *33)
                        except:
                            print('(STEP 3Z3/33) OF DOER2NELJA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            result2xi = calculate2nelja4xi(func, args)             
                            print('=' *33)
                            print('(STEP 3H/33) OF DOER2NELJA4XI - CALCULATED RESULT2XI: ', result2xi, ' ACK2RESULT: ', ack2result)
                            print('=' *33)
                            # 0 ... 28        
                        except:
                            print('(STEP 3Z4/33) OF DOER2NELJA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                        try:    
                            output_queue.put(result2xi)
                        
                            print('=' *33)
                            print('(STEP 3I/33) OF DOER2NELJA4XI - PUT CALCULATION: ', result2xi, ' TO OUTPUT_QUEUE: ', output_queue, ' FUNCTION: ', func, ' ARGS: ', args)
                            print('=' *33)
                            # 0   TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98>
                            # 28  TO OUTPUT_QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038F8F98> ...    
                        except:
                            print('(STEP 3Z5/33) OF DOER2NELJA4XI *** FAILED IN CALCULATION MISSION ', time4xi())
                            
                    print('(STEP 3J/33) OF DOER2NELJA4XI - COMPLETED ONE CALCULATION MISSION AND WAITING MORE ', time4xi())    
                    # 04:24:28 02/27/13 Pacific Standard Time                    
                time.sleep(0.2*random.random())                                                
    else:
        print("(STEP 3Y/33) OF DOER2NELJA4XI ** YIELDED CALCULATIONS BECAUSE OF FAILED COMMAND AND CONTROL - ACK2ROGER ** ", ack2roger)
        
    print('=' *33)
    print('(STEP 1C/33) OF DOER2NELJA4XI - RETURNING ', time4xi())
    # 05:17:30 02/26/13 Pacific Standard Time
    print('=' *33)   
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2nolla4xi" usage = "
#   worker function for Dragon4Xi 
#"> 
# -------------------------------------------------------------------------------------------------
def worker2nolla4xi(kb2dummy, index2dummy, input_queue, output_queue, consumer_channel, publisher_channel):
    print('~' *33)
    print('(STEP 0A/33) OF WORKER2NOLLA4XI - GOT INPUT QUEUE: ', input_queue)
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    
    print('(STEP 0B/33) OF WORKER2NOLLA4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
    
    print('(STEP 0C/33) OF WORKER2NOLLA4XI - GOT consumer_channel: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    
    print('(STEP 0D/33) OF WORKER2NOLLA4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        
    print('~' *33)
 

    # -----------------------------------------------------------------------------------------    
    # USING THE DUMMY PROCESS TO CHARGE - THIS APPROACH TRIES FASTER RETURN TO MAINPROCESS4XI  
    # -----------------------------------------------------------------------------------------      
    print("(STEP 1A/33) OF WORKER2NOLLA4XI - CREATING A DUMMY PROCESS4XI")  
    
    
    # -----------------------------------------------------------------------------------------    
    # CREATE THE DUMMY PROCESS OBJECT 
    # -----------------------------------------------------------------------------------------           
    try:                            
        kb2dummy[index2dummy] = DummyProcess4Xi(target=doer2nolla4xi, 
                                                args =(input_queue, output_queue, consumer_channel, publisher_channel))
                                                
        print("(STEP 2A/33) OF WORKER2NOLLA4XI - CREATED DUMMY: ", kb2dummy[index2dummy])
        # <DummyProcess4Xi(Thread-1, initial)> 
        # 
        ack2dummy = True
    except:
        print("(STEP 2Z/33) OF WORKER2NOLLA4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT *** ", time4xi())  
        ack2dummy = False
        
    # -----------------------------------------------------------------------------------------    
    # START THE DUMMY PROCESS OBJECT
    # -----------------------------------------------------------------------------------------              
    print("(STEP 3A/33) OF WORKER2NOLLA4XI - STARTING THE DUMMY PROCESS4XI ", time4xi())  
    #
    try:      
       kb2dummy[index2dummy].start() 
       print("(STEP 9E/33) OF WORKER2NOLLA4XI - STARTED THE DUMMY PROCESS4XI: ", kb2dummy[index2dummy])
       # <DummyProcess4Xi(Thread-1, started 2852)>
       # 
    except:
       print("(STEP 9F/33) OF WORKER2NOLLA4XI *** FAILED TO START THE DUMMY PROCESS4XI *** ", time4xi())  

    print("(STEP 33/33) OF WORKER2NOLLA4XI - RETURNING ", time4xi())  
    # 
    
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2yksi4xi" usage = "
#   worker function for Dragon4Xi 
#"> 
# -------------------------------------------------------------------------------------------------
def worker2yksi4xi(kb2dummy, index2dummy, input_queue, output_queue, consumer_channel, publisher_channel):
    print('~' *33)
    print('(STEP 0A/33) OF WORKER2YKSI4XI - GOT INPUT QUEUE: ', input_queue)
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    
    print('(STEP 0B/33) OF WORKER2YKSI4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
    
    print('(STEP 0C/33) OF WORKER2YKSI4XI - GOT consumer_channel: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    
    print('(STEP 0D/33) OF WORKER2YKSI4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        
    print('~' *33)
 

    # -----------------------------------------------------------------------------------------    
    # USING THE DUMMY PROCESS TO CHARGE - THIS APPROACH TRIES FASTER RETURN TO MAINPROCESS4XI  
    # -----------------------------------------------------------------------------------------      
    print("(STEP 1A/33) OF WORKER2YKSI4XI - CREATING A DUMMY PROCESS4XI")  
    
    
    # -----------------------------------------------------------------------------------------    
    # CREATE THE DUMMY PROCESS OBJECT 
    # -----------------------------------------------------------------------------------------           
    try:                            
        kb2dummy[index2dummy] = DummyProcess4Xi(target=doer2yksi4xi, 
                                                args =(input_queue, output_queue, consumer_channel, publisher_channel))
                                                
        print("(STEP 2A/33) OF WORKER2YKSI4XI - CREATED DUMMY: ", kb2dummy[index2dummy])
        # <DummyProcess4Xi(Thread-2, initial)>
        # 
        ack2dummy = True
    except:
        print("(STEP 2Z/33) OF WORKER2YKSI4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT *** ", time4xi())  
        ack2dummy = False
        
    # -----------------------------------------------------------------------------------------    
    # START THE DUMMY PROCESS OBJECT
    # -----------------------------------------------------------------------------------------              
    print("(STEP 3A/33) OF WORKER2YKSI4XI - STARTING THE DUMMY PROCESS4XI ", time4xi())  
    #
    try:      
       kb2dummy[index2dummy].start() 
       print("(STEP 9E/33) OF WORKER2YKSI4XI - STARTED THE DUMMY PROCESS4XI: ", kb2dummy[index2dummy])
       # <DummyProcess4Xi(Thread-2, started 1492)>
       # 
    except:
       print("(STEP 9F/33) OF WORKER2YKSI4XI *** FAILED TO START THE DUMMY PROCESS4XI *** ", time4xi())  

    print("(STEP 33/33) OF WORKER2YKSI4XI - RETURNING ", time4xi())  
    # 
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2kaksi4xi" usage = "
#   worker function for Dragon4Xi 
#"> 
# -------------------------------------------------------------------------------------------------
def worker2kaksi4xi(kb2dummy, index2dummy, input_queue, output_queue, consumer_channel, publisher_channel):
    print('~' *33)
    print('(STEP 0A/33) OF WORKER2KAKSI4XI - GOT INPUT QUEUE: ', input_queue)
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    
    print('(STEP 0B/33) OF WORKER2KAKSI4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
    
    print('(STEP 0C/33) OF WORKER2KAKSI4XI - GOT consumer_channel: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    
    print('(STEP 0D/33) OF WORKER2KAKSI4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        
    print('~' *33)
 

    # -----------------------------------------------------------------------------------------    
    # USING THE DUMMY PROCESS TO CHARGE - THIS APPROACH TRIES FASTER RETURN TO MAINPROCESS4XI  
    # -----------------------------------------------------------------------------------------      
    print("(STEP 1A/33) OF WORKER2KAKSI4XI - CREATING A DUMMY PROCESS4XI")  
    
    
    # -----------------------------------------------------------------------------------------    
    # CREATE THE DUMMY PROCESS OBJECT 
    # -----------------------------------------------------------------------------------------           
    try:                            
        kb2dummy[index2dummy] = DummyProcess4Xi(target=doer2kaksi4xi, 
                                                args =(input_queue, output_queue, consumer_channel, publisher_channel))
                                                
        print("(STEP 2A/33) OF WORKER2KAKSI4XI - CREATED DUMMY: ", kb2dummy[index2dummy])
        # <DummyProcess4Xi(Thread-3, initial)>
        # 
        ack2dummy = True
    except:
        print("(STEP 2Z/33) OF WORKER2KAKSI4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT *** ", time4xi())  
        ack2dummy = False
        
    # -----------------------------------------------------------------------------------------    
    # START THE DUMMY PROCESS OBJECT
    # -----------------------------------------------------------------------------------------              
    print("(STEP 3A/33) OF WORKER2KAKSI4XI - STARTING THE DUMMY PROCESS4XI ", time4xi())  
    #
    try:      
       kb2dummy[index2dummy].start() 
       print("(STEP 9E/33) OF WORKER2KAKSI4XI - STARTED THE DUMMY PROCESS4XI: ", kb2dummy[index2dummy])
       # <DummyProcess4Xi(Thread-3, started 2600)>
       # 
    except:
       print("(STEP 9F/33) OF WORKER2KAKSI4XI *** FAILED TO START THE DUMMY PROCESS4XI *** ", time4xi())  

    print("(STEP 33/33) OF WORKER2KAKSI4XI - RETURNING ", time4xi())  
    # 
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2kolme4xi" usage = "
#   worker function for Dragon4Xi 
#"> 
# -------------------------------------------------------------------------------------------------
def worker2kolme4xi(kb2dummy, index2dummy, input_queue, output_queue, consumer_channel, publisher_channel):
    print('~' *33)
    print('(STEP 0A/33) OF WORKER2KOLME4XI - GOT INPUT QUEUE: ', input_queue)
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    
    print('(STEP 0B/33) OF WORKER2KOLME4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
    
    print('(STEP 0C/33) OF WORKER2KOLME4XI - GOT consumer_channel: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    
    print('(STEP 0D/33) OF WORKER2KOLME4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        
    print('~' *33)
 

    # -----------------------------------------------------------------------------------------    
    # USING THE DUMMY PROCESS TO CHARGE - THIS APPROACH TRIES FASTER RETURN TO MAINPROCESS4XI  
    # -----------------------------------------------------------------------------------------      
    print("(STEP 1A/33) OF WORKER2KOLME4XI - CREATING A DUMMY PROCESS4XI")  
    
    
    # -----------------------------------------------------------------------------------------    
    # CREATE THE DUMMY PROCESS OBJECT 
    # -----------------------------------------------------------------------------------------           
    try:                            
        kb2dummy[index2dummy] = DummyProcess4Xi(target=doer2kolme4xi, 
                                                args =(input_queue, output_queue, consumer_channel, publisher_channel))
                                                
        print("(STEP 2A/33) OF WORKER2KOLME4XI - CREATED DUMMY: ", kb2dummy[index2dummy])
        # <DummyProcess4Xi(Thread-4, initial)>
        # 
        ack2dummy = True
    except:
        print("(STEP 2Z/33) OF WORKER2KOLME4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT *** ", time4xi())  
        ack2dummy = False
        
    # -----------------------------------------------------------------------------------------    
    # START THE DUMMY PROCESS OBJECT
    # -----------------------------------------------------------------------------------------              
    print("(STEP 3A/33) OF WORKER2KOLME4XI - STARTING THE DUMMY PROCESS4XI ", time4xi())  
    #
    try:      
       kb2dummy[index2dummy].start() 
       print("(STEP 9E/33) OF WORKER2KOLME4XI - STARTED THE DUMMY PROCESS4XI: ", kb2dummy[index2dummy])
       # <DummyProcess4Xi(Thread-4, started 2812)>
       # 
    except:
       print("(STEP 9F/33) OF WORKER2KOLME4XI *** FAILED TO START THE DUMMY PROCESS4XI *** ", time4xi())  

    print("(STEP 33/33) OF WORKER2KOLME4XI - RETURNING ", time4xi())  
    # 
    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "worker2nelja4xi" usage = "
#   worker function for Dragon4Xi 
#"> 
# -------------------------------------------------------------------------------------------------
def worker2nelja4xi(kb2dummy, index2dummy, input_queue, output_queue, consumer_channel, publisher_channel):
    print('~' *33)
    print('(STEP 0A/33) OF WORKER2NELJA4XI - GOT INPUT QUEUE: ', input_queue)
    # <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
    # 
    
    print('(STEP 0B/33) OF WORKER2NELJA4XI - GOT OUTPUT QUEUE: ', output_queue)
    # <queue4xi.Queue4Xi object at 0x00000000037BDC88>
    # 
    
    print('(STEP 0C/33) OF WORKER2NELJA4XI - GOT consumer_channel: ', consumer_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
    
    print('(STEP 0D/33) OF WORKER2NELJA4XI - GOT PUBLISHER_CHANNEL: ', publisher_channel)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        
    print('~' *33)
 

    # -----------------------------------------------------------------------------------------    
    # USING THE DUMMY PROCESS TO CHARGE - THIS APPROACH TRIES FASTER RETURN TO MAINPROCESS4XI  
    # -----------------------------------------------------------------------------------------      
    print("(STEP 1A/33) OF WORKER2NELJA4XI - CREATING A DUMMY PROCESS4XI")  
    
    
    # -----------------------------------------------------------------------------------------    
    # CREATE THE DUMMY PROCESS OBJECT 
    # -----------------------------------------------------------------------------------------           
    try:                            
        kb2dummy[index2dummy] = DummyProcess4Xi(target=doer2nelja4xi, 
                                                args =(input_queue, output_queue, consumer_channel, publisher_channel))
                                                
        print("(STEP 2A/33) OF WORKER2NELJA4XI - CREATED DUMMY: ", kb2dummy[index2dummy])
        # <DummyProcess4Xi(Thread-5, initial)>
        # 
        ack2dummy = True
    except:
        print("(STEP 2Z/33) OF WORKER2NELJA4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT *** ", time4xi())  
        ack2dummy = False
        
    # -----------------------------------------------------------------------------------------    
    # START THE DUMMY PROCESS OBJECT
    # -----------------------------------------------------------------------------------------              
    print("(STEP 3A/33) OF WORKER2NELJA4XI - STARTING THE DUMMY PROCESS4XI ", time4xi())  
    #
    try:      
       kb2dummy[index2dummy].start() 
       print("(STEP 9E/33) OF WORKER2NELJA4XI - STARTED THE DUMMY PROCESS4XI: ", kb2dummy[index2dummy])
       # <DummyProcess4Xi(Thread-5, started 5040)>
       # 
    except:
       print("(STEP 9F/33) OF WORKER2NELJA4XI *** FAILED TO START THE DUMMY PROCESS4XI *** ", time4xi())  

    print("(STEP 33/33) OF WORKER2NELJA4XI - RETURNING ", time4xi())  
    # 
    
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate" usage = "
#   calculation function for standard multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def calculate(func, args):
    result = func(*args)
    return 'Standard Multiprocessing %s says that %s%s = %s' % \
        (current_process().name, func.__name__, args, result)
        
#Process -1: 4 says, -2: 6 says, -3: 4 says, -4: 6 says, TOTAL 20 says = OK 
#reasoning: each process has something to say, not necessary as many times as other processes ! 
           
#   Standard Multiprocessing Process-4 says that multiply(2, 7) = 14
#   Standard Multiprocessing Process-3 says that multiply(3, 7) = 21
#   Standard Multiprocessing Process-2 says that multiply(0, 7) = 0
#   Standard Multiprocessing Process-1 says that multiply(1, 7) = 7
#   Standard Multiprocessing Process-2 says that multiply(6, 7) = 42
#   Standard Multiprocessing Process-4 says that multiply(4, 7) = 28
#   Standard Multiprocessing Process-3 says that multiply(5, 7) = 35
#   Standard Multiprocessing Process-4 says that multiply(9, 7) = 63
#   Standard Multiprocessing Process-4 says that multiply(11, 7) = 77
#   Standard Multiprocessing Process-4 says that multiply(12, 7) = 84
#   Standard Multiprocessing Process-2 says that multiply(8, 7) = 56
#   Standard Multiprocessing Process-1 says that multiply(7, 7) = 49
#   Standard Multiprocessing Process-1 says that multiply(15, 7) = 105
#   Standard Multiprocessing Process-3 says that multiply(10, 7) = 70
#   Standard Multiprocessing Process-2 says that multiply(14, 7) = 98
#   Standard Multiprocessing Process-2 says that multiply(18, 7) = 126
#   Standard Multiprocessing Process-1 says that multiply(16, 7) = 112
#   Standard Multiprocessing Process-3 says that multiply(17, 7) = 119
#   Standard Multiprocessing Process-4 says that multiply(13, 7) = 91
#   Standard Multiprocessing Process-2 says that multiply(19, 7) = 133     

#   Standard Multiprocessing Process-2 says that add(3, 8) = 11
#   Standard Multiprocessing Process-3 says that add(1, 8) = 9
#   Standard Multiprocessing Process-2 says that add(4, 8) = 12
#   Standard Multiprocessing Process-3 says that add(5, 8) = 13
#   Standard Multiprocessing Process-4 says that add(2, 8) = 10
#   Standard Multiprocessing Process-1 says that add(0, 8) = 8
#   Standard Multiprocessing Process-3 says that add(7, 8) = 15
#   Standard Multiprocessing Process-2 says that add(6, 8) = 14
#   Standard Multiprocessing Process-1 says that add(9, 8) = 17
#   Standard Multiprocessing Process-4 says that add(8, 8) = 16
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2xi" usage = "
#   calculation function for Dragon2Xi multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2xi(func, args):
    result = func(*args)
    return 'Dragon2Xi Multiprocessing %s says that %s%s = %s' % \
        (current_process().name, func.__name__, args, result)

# STARTING TEST2 WITH HYBRID MULTIPROCESSING
# 
# TEST2: TESTS CALCULATIONS WITH HYBRID MULTIPROCESSING
# 
# TEST2: CREATE QUEUES WITH HYBRID MULTIPROCESSING
# 
# TEST2: SUBMIT TASKS WITH HYBRID MULTIPROCESSING
# 
# TEST2: START WORKER PROCESSES WITH HYBRID MULTIPROCESSING
# 
# TEST2: GET AND PRINT RESULTS WITH HYBRID MULTIPROCESSING
# Unordered results:
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(2, 7) = 14
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(3, 7) = 21
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(0, 7) = 0
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(1, 7) = 7
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(5, 7) = 35
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(7, 7) = 49
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(4, 7) = 28
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(6, 7) = 42
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(11, 7) = 77
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(9, 7) = 63
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(12, 7) = 84
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(8, 7) = 56
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(10, 7) = 70
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(14, 7) = 98
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(13, 7) = 91
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(17, 7) = 119
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(16, 7) = 112
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(15, 7) = 105
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(19, 7) = 133
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(18, 7) = 126
# 
# TEST2: ADD MORE TASKS USING PUT WITH HYBRID MULTIPROCESSING
# 
# TEST2: GET AND PRINT SOME MORE RESULTS WITH HYBRID MULTIPROCESSING
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that add(1, 8) = 9
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that add(4, 8) = 12
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that add(0, 8) = 8
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that add(2, 8) = 10
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that add(3, 8) = 11
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that add(7, 8) = 15
# 	 Dragon2Xi Multiprocessing Process2Xi-8 says that add(5, 8) = 13
# 	 Dragon2Xi Multiprocessing Process2Xi-7 says that add(6, 8) = 14
# 	 Dragon2Xi Multiprocessing Process2Xi-5 says that add(9, 8) = 17
# 	 Dragon2Xi Multiprocessing Process2Xi-6 says that add(8, 8) = 16
# 
# TEST2: TELL CHILD PROCESSES TO STOP WITH HYBRID MULTIPROCESSING
# 
# TEST2 COMPLETED WITH HYBRID MULTIPROCESSING 
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "multiply" usage = "
#   multiplying - common 
#"> 
# -------------------------------------------------------------------------------------------------
def multiply(a, b):
    time.sleep(0.5*random.random())
    return a * b
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "add" usage = "
#   addition - common
#"> 
# -------------------------------------------------------------------------------------------------
def add(a, b):
    time.sleep(0.5*random.random())
    return a + b
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate4xi" usage = "
#   calculation function for Dragon4Xi multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def calculate4xi(func, args):
    result2xi = func(*args)
    return '%s says that %s%s = %s' % \
        (get_name_current_process4xi(), func.__name__, args, result2xi)                
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2nolla4xi" usage = "
#   calculation function for multiprocessing4xi
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2nolla4xi(func, args):
    result2nolla = func(*args)
    return result2nolla
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2yksi4xi" usage = "
#   calculation function for multiprocessing4xi
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2yksi4xi(func, args):
    result2yksi = func(*args)
    return result2yksi
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2kaksi4xi" usage = "
#   calculation function for multiprocessing4xi
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2kaksi4xi(func, args):
    result2kaksi = func(*args)
    return result2kaksi
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2kolme4xi" usage = "
#   calculation function for multiprocessing4xi
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2kolme4xi(func, args):
    result2kolme = func(*args)
    return result2kolme
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "calculate2nelja4xi" usage = "
#   calculation function for multiprocessing4xi
#"> 
# -------------------------------------------------------------------------------------------------
def calculate2nelja4xi(func, args):
    result2nelja = func(*args)
    return result2nelja
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test1" usage = "
#   tests calculations with standard multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def test1():

    global task_queue
    global done_queue

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    print("\nTEST1; STARTING MATH TESTS WITH STANDARD MULTIPROCESSING ", time4xi())    
    # 01:36:44 02/25/13 Pacific Standard Time
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST1: TESTS CALCULATIONS WITH STANDARD MULTIPROCESSING ", time4xi())
    # 01:36:44 02/25/13 Pacific Standard Time
    
    NUMBER_OF_PROCESSES = 4
    TASKS1 = [(multiply, (i, 7)) for i in range(20)]
    TASKS2 = [(add, (i, 8)) for i in range(10)]

    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST1: CREATING QUEUES WITH STANDARD MULTIPROCESSING ", time4xi())    
    task_queue = Queue()
    print("\nTEST1: CREATED TASK_QUEUE WITH STANDARD MULTIPROCESSING ", task_queue) 
    # <multiprocessing.queues.Queue object at 0x00000000029F22E8>
    
    done_queue = Queue()
    print("\nTEST1: CREATED DONE_QUEUE WITH STANDARD MULTIPROCESSING ", done_queue) 
    # <multiprocessing.queues.Queue object at 0x0000000003683278>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST1: SUBMITTING TASKS VIA QUEUE WITH STANDARD MULTIPROCESSING ", time4xi())     

    for task in TASKS1:
        task_queue.put(task)
        print("\nTEST1: PUT TO TASK_QUEUE: ", task_queue, " TASK: ", task)
        # PUT TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function multiply at 0x00000000036879D8>, (0, 7))
        # ...
        # <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function multiply at 0x00000000036879D8>, (19, 7))
        
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST1: START WORKER PROCESSES WITH STANDARD MULTIPROCESSING ", time4xi()) 

    for i in range(NUMBER_OF_PROCESSES+1):
        Process(target=worker, args=(task_queue, done_queue)).start()
        print("\nTEST1: STARTED WORKER PROCESS WITH WORK: ", worker, " TASK_QUEUE: ", task_queue, " DONE_QUEUE: ", done_queue)
        # <function worker at 0x00000000036876A8>  TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # <function worker at 0x00000000036876A8>  TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # <function worker at 0x00000000036876A8>  TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # <function worker at 0x00000000036876A8>  TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST1: GET AND PRINT RESULTS WITH STANDARD MULTIPROCESSING ", time4xi()) 

    print ('Unordered results:')
    for i in range(len(TASKS1)):
        result = done_queue.get()
        print ('\t', ' RESULT: ',  result, ' FROM DONE_QUEUE: ', done_queue)
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(3, 7) = 21  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that multiply(2, 7) = 14  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that multiply(0, 7) = 0  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that multiply(1, 7) = 7  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that multiply(5, 7) = 35  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(4, 7) = 28  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that multiply(7, 7) = 49  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that multiply(8, 7) = 56  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that multiply(6, 7) = 42  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that multiply(12, 7) = 84  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(9, 7) = 63  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(14, 7) = 98  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that multiply(13, 7) = 91  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that multiply(10, 7) = 70  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that multiply(11, 7) = 77  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(15, 7) = 105  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that multiply(16, 7) = 112  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that multiply(18, 7) = 126  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that multiply(19, 7) = 133  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that multiply(17, 7) = 119  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278> 
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST1: ADD MORE TASKS USING PUT WITH STANDARD MULTIPROCESSING ", time4xi()) 

    for task in TASKS2:
        task_queue.put(task)
        print("\nTEST1: PUT MORE TO TASK_QUEUE: ", task_queue, " TASK: ", task)
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (0, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (1, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (2, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (3, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (4, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (5, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (6, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (7, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (8, 8))
        #  PUT MORE TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>  TASK:  (<function add at 0x0000000003687A60>, (9, 8))        
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST1: GET AND PRINT SOME MORE RESULTS WITH STANDARD MULTIPROCESSING ", time4xi()) 

    for i in range(len(TASKS2)):
        result = done_queue.get()
        print ('\t', ' RESULT: ',  result, ' FROM DONE_QUEUE: ', done_queue)
        # RESULT:  Standard Multiprocessing Process-3 says that add(2, 8) = 10  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that add(1, 8) = 9  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that add(3, 8) = 11  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that add(0, 8) = 8  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that add(5, 8) = 13  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that add(8, 8) = 16  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-4 says that add(7, 8) = 15  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-1 says that add(9, 8) = 17  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-2 says that add(6, 8) = 14  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>
        # RESULT:  Standard Multiprocessing Process-3 says that add(4, 8) = 12  FROM DONE_QUEUE:  <multiprocessing.queues.Queue object at 0x0000000003683278>  
          
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST1: TELL CHILD PROCESSES TO STOP WITH STANDARD MULTIPROCESSING ", time4xi()) 

    for i in range(NUMBER_OF_PROCESSES+1):
        task_queue.put('STOP')
        print("\nTEST1: PUT STOP TO TASK_QUEUE: ", task_queue)
        # PUT STOP TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>
        # PUT STOP TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>
        # PUT STOP TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8>
        # PUT STOP TO TASK_QUEUE:  <multiprocessing.queues.Queue object at 0x00000000029F22E8> 
              
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print("\nTEST1 COMPLETED WITH STANDARD MULTIPROCESSING ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test2" usage = "
#   tests calculations with hyprid multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def test2():

    global task_queue2xi
    global done_queue2xi

    # ---------------------------------------------------------------------------------------------    
    # STARTING
    # ---------------------------------------------------------------------------------------------   
    print("\nSTARTING TEST2 WITH HYBRID MULTIPROCESSING ", time4xi())    
    # 01:36:46 02/25/13 Pacific Standard Time
    
    # ---------------------------------------------------------------------------------------------    
    # DEFINE TASKS1 AND TASKS2
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST2: TESTS CALCULATIONS WITH HYBRID MULTIPROCESSING ", time4xi())
    # 01:36:46 02/25/13 Pacific Standard Time
    NUMBER_OF_PROCESSES = 4
    TASKS1 = [(multiply, (i, 7)) for i in range(20)]
    TASKS2 = [(add, (i, 8)) for i in range(10)]

    
    # ---------------------------------------------------------------------------------------------    
    # CREATE ONE TASK AND ONE DONE QUEUE
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST2: CREATE QUEUES FOR HYBRID MULTIPROCESSING ", time4xi())    
    # 01:36:46 02/25/13 Pacific Standard Time
    task_queue2xi = Queue2Xi()
    done_queue2xi = Queue2Xi()
    
    # ---------------------------------------------------------------------------------------------    
    # PUT TASKS1 TO TASK QUEUE
    # ---------------------------------------------------------------------------------------------     

    print("\nTEST2: PUT TASKS1 TO TASK_QUEUE2XI FOR HYBRID MULTIPROCESSING ", time4xi())     
    # 01:36:46 02/25/13 Pacific Standard Time
    for task in TASKS1:
        task_queue2xi.put(task)
    
    # ---------------------------------------------------------------------------------------------    
    # START ALL PROCESSES WITH THE SAME TARGET FUNCTION AND ONE TASK- AND DONE-QUEUE 
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST2: START PROCESSES WITH THE SAME TARGET FUNCTION AND ONE TASK- AND DONE-QUEUE FOR HYBRID MULTIPROCESSING ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
    for i in range(NUMBER_OF_PROCESSES+1):
        Process2Xi(target=worker2xi, args=(task_queue2xi, done_queue2xi)).start()
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST2: GET RESULTS FROM ONE DONE QUEUE ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
    print ('Unordered results:')
    for i in range(len(TASKS1)):
        print ('\t', done_queue2xi.get())
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(0, 7) = 0
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(4, 7) = 28
        # Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(3, 7) = 21
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(5, 7) = 35
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(1, 7) = 7
        # Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(2, 7) = 14
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(8, 7) = 56
        # Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(6, 7) = 42
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(7, 7) = 49
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(12, 7) = 84
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(10, 7) = 70
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(13, 7) = 91
        # Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(9, 7) = 63
        # Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(11, 7) = 77
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(14, 7) = 98
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(18, 7) = 126
        # Dragon2Xi Multiprocessing Process2Xi-6 says that multiply(16, 7) = 112
        # Dragon2Xi Multiprocessing Process2Xi-7 says that multiply(15, 7) = 105
        # Dragon2Xi Multiprocessing Process2Xi-5 says that multiply(17, 7) = 119
        # Dragon2Xi Multiprocessing Process2Xi-8 says that multiply(19, 7) = 133
            
    # ---------------------------------------------------------------------------------------------    
    # PUT MORE TASKS
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST2: PUT MORE TASKS FOR HYBRID MULTIPROCESSING ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
    
    for task in TASKS2:
        task_queue2xi.put(task)
    
    # ---------------------------------------------------------------------------------------------    
    # GET NEW RESULTS
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST2: GET NEW RESULTS WITH HYBRID MULTIPROCESSING ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
    
    for i in range(len(TASKS2)):
        print ('\t', done_queue2xi.get())
        # 
        # Note: target function returning the process info takes the knowledge checking the current process!
        #       
        # Dragon2Xi Multiprocessing Process2Xi-8 says that add(3, 8) = 11
        # Dragon2Xi Multiprocessing Process2Xi-8 says that add(4, 8) = 12
        # Dragon2Xi Multiprocessing Process2Xi-7 says that add(1, 8) = 9
        # Dragon2Xi Multiprocessing Process2Xi-5 says that add(2, 8) = 10
        # Dragon2Xi Multiprocessing Process2Xi-5 says that add(7, 8) = 15
        # Dragon2Xi Multiprocessing Process2Xi-7 says that add(6, 8) = 14
        # Dragon2Xi Multiprocessing Process2Xi-6 says that add(0, 8) = 8
        # Dragon2Xi Multiprocessing Process2Xi-8 says that add(5, 8) = 13
        # Dragon2Xi Multiprocessing Process2Xi-7 says that add(9, 8) = 17
        # Dragon2Xi Multiprocessing Process2Xi-5 says that add(8, 8) = 16 
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
        
    print("\nTEST2: TELL CHILD PROCESSES TO STOP WITH HYBRID MULTIPROCESSING ", time4xi()) 

    for i in range(NUMBER_OF_PROCESSES+1):
        task_queue2xi.put('STOP')
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print("\nTEST2 COMPLETED WITH HYBRID MULTIPROCESSING ", time4xi()) 
    # 01:36:46 02/25/13 Pacific Standard Time
    
#</function4xi>                
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test4" usage = "
#   tests calculations with dragonized multiprocessing
#"> 
# -------------------------------------------------------------------------------------------------
def test4():


    # ---------------------------------------------------------------------------------------------    
    # (STEP 0/33) - START - OK
    # ---------------------------------------------------------------------------------------------   
    print("\n(STEP 0/33) OF TEST4 - STARTING TEST4 WITH DRAGON4XI MULTIPROCESSING4XI ", time4xi())    
    # 07:17:15 02/25/13 Pacific Standard Time
       
    # ---------------------------------------------------------------------------------------------    
    # (STEP 1/33) - SET TASKS - OK
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("\n(STEP 1/33) OF TEST4 - STARTING TO TEST CALCULATIONS WITH DRAGON4XI MULTIPROCESSING4Xi ", time4xi()) 
    # 07:17:15 02/25/13 Pacific Standard Time
    
    NUMBER_OF_PROCESSES = cpu_corecount4xi()                                            #dragonized
    print("\n(STEP 1A/33) OF TEST4 - NUMBER_OF_PROCESSES: ", NUMBER_OF_PROCESSES) 
    # 4
    
    # WE SET THE SAME TASKS FOR EACH FUNCTION RUNNING AS A THREAD - AND ACTIVATED BY THE TARGET FUNCTION OF THE PROCESS
    # THIS SIMULATES THE SITUATION WHERE ONE MAKES SURE DIFFERENT PROCESSING UNITS GIVE THE SAME RESULTS
    
    kb2task1 = {}
    for key2task1 in range(NUMBER_OF_PROCESSES+1):
        kb2task1[key2task1] = [(multiply, (i, 7)) for i in range(20)]    
        print("KB2TASK1[", key2task1, "]: ", kb2task1[key2task1])
        # KB2TASK1[ 0 ]:  [(<function multiply at 0x00000000036A1E18>, (0, 7)), (<function multiply at 0x00000000036A1E18>, (1, 7)), (<function multiply at 0x00000000036A1E18>, (2, 7)) ...
        # ...
        # KB2TASK1[ 4 ]:  [(<function multiply at 0x00000000036A1E18>, (0, 7)), (<function multiply at 0x00000000036A1E18>, (1, 7)), (<function multiply at 0x00000000036A1E18>, (2, 7)) ...
         
    kb2task2 = {}
    for key2task2 in range(NUMBER_OF_PROCESSES+1):
        kb2task2[key2task2] = [(add, (i, 8)) for i in range(10)]
        print("KB2TASK2[", key2task2, "]: ", kb2task2[key2task2])     
        # KB2TASK2[ 0 ]:  [(<function add at 0x00000000036A1EA0>, (0, 8)), (<function add at 0x00000000036A1EA0>, (1, 8)), (<function add at 0x00000000036A1EA0> ...
        # ...
        # KB2TASK2[ 4 ]:  [(<function add at 0x00000000036A1EA0>, (0, 8)), (<function add at 0x00000000036A1EA0>, (1, 8)), (<function add at 0x00000000036A1EA0> ...
        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 2/33) - CREATE PIPES WITH CONSUMER AND PUBLISHER CHANNELS FOR EACH TARGET FUNCTION - OK
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 2/33) OF TEST4 - STARTING TO CREATE PIPES WITH CONSUMER AND PUBLISHER CHANNELS ", time4xi())      
    # 
    kb2consumer4channel = {}
    kb2publisher4channel = {} 
    for key2channel in range(NUMBER_OF_PROCESSES+1):
        try:
            kb2consumer4channel[key2channel], kb2publisher4channel[key2channel] = Pipe4Xi()
            print("\n(STEP 2A/33) OF TEST4 - CREATED CONSUMER CHANNEL ", key2channel, " ", kb2consumer4channel[key2channel])        
            # CONSUMER CHANNEL  0   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3400>
            # CONSUMER CHANNEL  1   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3780>
            # CONSUMER CHANNEL  2   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3748>
            # CONSUMER CHANNEL  3   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3630>
            # CONSUMER CHANNEL  4   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3668>
            
            print("\n(STEP 2B/33) OF TEST4 - CREATED PUBLISHER CHANNEL ", key2channel, " ", kb2publisher4channel[key2channel])       
            # PUBLISHER CHANNEL  0   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C32E8>
            # PUBLISHER CHANNEL  1   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3710>
            # PUBLISHER CHANNEL  2   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C37F0>
            # PUBLISHER CHANNEL  3   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C35C0>
            # PUBLISHER CHANNEL  4   <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C36A0>
        except:
            print("\n(STEP 2Z/33) OF TEST4 *** FAILED TO CREATE PIPES WITH CONSUMER AND PUBLISHER CHANNELS ", time4xi())      
        

        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 3/33) - CREATE TASK AND DONE QUEUES FOR EACH TARGET FUNCTION - OK
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 3/33) OF TEST4 - STARTING TO CREATE QUEUES TASK AND DONE ", time4xi())    
    # 05:17:26 02/26/13 Pacific Standard Time
    kb2queue4task = {} 
    for key2queue in range(NUMBER_OF_PROCESSES+1):
        try:
            kb2queue4task[key2queue] = Queue4Xi()
            print("\n(STEP 3A/33) OF TEST4 - CREATED PROCESS ", key2queue, " QUEUE: ", kb2queue4task[key2queue])        
            # CREATED TASK  0  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000002A5A2E8> 
            # CREATED TASK  1  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDA20>
            # CREATED TASK  2  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BD8D0>   
            # CREATED TASK  3  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BD9E8>   
            # CREATED TASK  4  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDB38>
        except:
            print("\n(STEP 3Z/33) OF TEST4 *** FAILED TO CREATE TASK QUEUE- KEY2QUEUE: ", key2queue)    

    kb2queue4done = {} 
    for key2queue in range(NUMBER_OF_PROCESSES+1):
        try:
            kb2queue4done[key2queue] = Queue4Xi()
            print("\n(STEP 3A/33) OF TEST4 - CREATED DONE ", key2queue, " QUEUE: ", kb2queue4done[key2queue])        
            # DONE  0  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDC88> 
            # DONE  1  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDDD8>
            # DONE  2  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDF28>
            # DONE  3  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038AE0B8>
            # DONE  4  QUEUE:  <queue4xi.Queue4Xi object at 0x00000000038AE208>
        except:
            print("\n(STEP 3Z/33) OF TEST4 *** FAILED TO CREATE DONE QUEUE- KEY2QUEUE: ", key2queue)         
            
                                                  
    # -------------------------------------------------------------------------------------------------
    # (STEP 4/33) - SEND COMMAND AND CONTROL MESSAGES TO PIPE PUBLISHER4CHANNELS - OK               
    # -------------------------------------------------------------------------------------------------                 
    for key2channel in range(NUMBER_OF_PROCESSES+1):
        try:
            message2send4cc = "<copy4xi>" + str(key2channel) + "</copy4xi>"
            kb2publisher4channel[key2channel].send(message2send4cc)
               
            print("\n (STEP 4A/33) OF OF TEST4 - SENT TO KB2PUBLISHER4CHANNEL[", key2channel, "]: ", kb2publisher4channel[key2channel], " MESSAGE: ", message2send4cc)
            # KB2PUBLISHER4CHANNEL[ 0 ]:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C32E8>  MESSAGE:  <copy4xi>0</copy4xi>
            # KB2PUBLISHER4CHANNEL[ 1 ]:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C3710>  MESSAGE:  <copy4xi>1</copy4xi>
            # KB2PUBLISHER4CHANNEL[ 2 ]:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C37F0>  MESSAGE:  <copy4xi>2</copy4xi>
            # KB2PUBLISHER4CHANNEL[ 3 ]:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C35C0>  MESSAGE:  <copy4xi>3</copy4xi>
            # KB2PUBLISHER4CHANNEL[ 4 ]:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000038C36A0>  MESSAGE:  <copy4xi>4</copy4xi>
        except:
            print("\n (STEP 4Z/33) OF OF TEST4 *** FAILED TO SEND TO KB2PUBLISHER4CHANNEL - KEY2CHANNEL:", key2channel)    
                         
    # ---------------------------------------------------------------------------------------------    
    # (STEP 5/33) - PUT TASK1 TO TASK QUEUS - OK 
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 5/33) OF TEST4 - STARTING TO PUT KB2TASK1 ", kb2task1)   
    # 
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            kb2queue4task[key2mission].put(kb2task1[key2mission])
            
            print("\n(STEP 5A/33) OF TEST4 - PUT FOR MISSION: ", key2mission, " TASK: ", kb2task1[key2mission], " TO QUEUE: ", kb2queue4task[key2mission])
            # PUT FOR MISSION:  0  TASK:  [(<function multiply at 0x00000000037C4E18>, (0, 7)), (<function multiply at 0x00000000037C4E18>, (1, 7)) ...
            # PUT FOR MISSION:  1  TASK:  [(<function multiply at 0x00000000037C4E18>, (0, 7)), (<function multiply at 0x00000000037C4E18>, (1, 7)) ...
            # PUT FOR MISSION:  2  TASK:  [(<function multiply at 0x00000000037C4E18>, (0, 7)), (<function multiply at 0x00000000037C4E18>, (1, 7)) ...
            # PUT FOR MISSION:  3  TASK:  [(<function multiply at 0x00000000037C4E18>, (0, 7)), (<function multiply at 0x00000000037C4E18>, (1, 7)) ...
            # PUT FOR MISSION:  4  TASK:  [(<function multiply at 0x00000000037C4E18>, (0, 7)), (<function multiply at 0x00000000037C4E18>, (1, 7)) ...
            
    except:
        print("\n(STEP 5Z/33) OF TEST4 *** FAILED TO PUT KB2TASK1 ", kb2task1)  
        

                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 7/33) - CREATE PROCESSES - OK
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 7/33) OF TEST4 - STARTING TO CREATE PROCESSES ", time4xi())   
    # 01:31:54 02/26/13 Pacific Standard Time
    
    ack2dummy = False
    if ack2dummy is False:
        print("\n(STEP 7A/33) OF TEST4 - REAL PROCESSES Process4Xi ARE BEING USED ", time4xi())
        # 05:06:00 02/26/13 Pacific Standard Time 
    else:
        print("\n(STEP 7B/33) OF TEST4 - DUMMY PROCESSES DummyProcess4Xi ARE BEING USED ", time4xi())       
    
    kb2worker = {}
    kb2worker[0] = worker2nolla4xi
    kb2worker[1] = worker2yksi4xi
    kb2worker[2] = worker2kaksi4xi
    kb2worker[3] = worker2kolme4xi 
    kb2worker[4] = worker2nelja4xi
    keys2worker = kb2worker.keys()
    for key2worker in keys2worker:
        print("\n(STEP 7C/33) OF TEST4 - kb2worker[", key2worker, "]: ",  kb2worker[key2worker]) 
        # kb2worker[ 0 ]:  <function worker2nolla4xi at 0x000000000384D0D0>
        # kb2worker[ 1 ]:  <function worker2yksi4xi at 0x000000000384D158>
        # kb2worker[ 2 ]:  <function worker2kaksi4xi at 0x000000000384D1E0>
        # kb2worker[ 3 ]:  <function worker2kolme4xi at 0x000000000384D268>
        # kb2worker[ 4 ]:  <function worker2nelja4xi at 0x000000000384D2F0>
    
    kb2dummy = {}
    for i in range(NUMBER_OF_PROCESSES+1):
        kb2dummy[i] = i 
    
    kb2process = {}
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            if ack2dummy is True:
                kb2process[key2mission] = DummyProcess4Xi(target=kb2worker[key2mission], args=(kb2dummy, key2mission, kb2queue4task[key2mission], kb2queue4done[key2mission], kb2consumer4channel[key2mission], kb2publisher4channel[key2mission]))
            
            else:
                kb2process[key2mission] = Process4Xi(target=kb2worker[key2mission], args=(kb2dummy, key2mission, kb2queue4task[key2mission], kb2queue4done[key2mission], kb2consumer4channel[key2mission], kb2publisher4channel[key2mission]))
            
            
            print("\n(STEP 7B/33) OF TEST4 - CREATED FOR MISSION: ", key2mission, " PROCESS : ", kb2process[key2mission])
            # <Process4Xi(Process4Xi-1, initial)>
            # <Process4Xi(Process4Xi-2, initial)>
            # <Process4Xi(Process4Xi-3, initial)>
            # <Process4Xi(Process4Xi-4, initial)>
            # <Process4Xi(Process4Xi-5, initial)>
    except:
        print("\n(STEP 7Z/33) OF TEST4 *** FAILED TO CREATE PROCESSES ", time4xi())
                
                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 8/33) - START PROCESSES - EACH WITH OWN TARGET FUNCTION - OK
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 8/33) OF TEST4 - STARTING PROCESSES ", time4xi())  
    
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            kb2process[key2mission].start()
            
            print("\n(STEP 8A/33) OF TEST4 - STARTED FOR MISSION: ", key2mission, " PROCESS : ", kb2process[key2mission])
            # <Process4Xi(Process4Xi-1, stopped)>
            # ...
            # <Process4Xi(Process4Xi-5, stopped)>
    except:
        print("\n(STEP 8Z/33) OF TEST4 *** FAILED TO START PROCESSES ", time4xi())
            
                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 9/33) - RUN PROCESSES - EACH WITH OWN TARGET FUNCTION - OK
    # ---------------------------------------------------------------------------------------------     
    if ack2dummy is True:
        print("\n(STEP 9A/33) OF TEST4 - SKIPPED RUNNING DUMMY PROCESSES ", time4xi()) 
    else:
        print("\n(STEP 9B/33) OF TEST4 - RUNNING PROCESSES ", time4xi())  
        # 01:31:58 02/26/13 Pacific Standard Time
        # target function starts to operate:
        # (STEP 0A/33) OF WORKER4XI - GOT INPUT QUEUE:  <queue4xi.Queue4Xi object at 0x0000000002A5A2E8>
        # (STEP 0B/33) OF WORKER4XI - GOT OUTPUT QUEUE:  <queue4xi.Queue4Xi object at 0x00000000037BDC88>
        # (STEP 0C/33) OF WORKER4XI - GOT consumer_channel:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD320>
        # (STEP 0D/33) OF WORKER4XI - GOT PUBLISHER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BD208>
        # ...
        try:
            for key2mission in range(NUMBER_OF_PROCESSES+1):
                kb2process[key2mission].run()
                
                print("\n(STEP 9C/33) OF TEST4 - RUN FOR MISSION: ", key2mission, " PROCESS : ", kb2process[key2mission])
                # 
        except:
            print("\n(STEP 9Z1/33) OF TEST4 *** FAILED TO RUN PROCESSES ", time4xi())
        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 10/33) - DUMMY PROCESSES CREATED BY TARGET FUNCTIONS OF PROCESSES - OK
    # ---------------------------------------------------------------------------------------------     
    print("\n(STEP 10/33) OF TEST4 - DUMMY PROCESSES CREATED BY WORKER FUNCTIONS ", time4xi()) 
    keys2dummy = kb2dummy.keys()
    for key2dummy in keys2dummy:
        print("KB2DUMMY[", key2dummy, "]: ", kb2dummy[key2dummy])      
        # KB2DUMMY[ 0 ]:  <DummyProcess4Xi(Thread-1, stopped 2852)>
        # KB2DUMMY[ 1 ]:  <DummyProcess4Xi(Thread-2, stopped 1492)>
        # KB2DUMMY[ 2 ]:  <DummyProcess4Xi(Thread-3, stopped 2600)>
        # KB2DUMMY[ 3 ]:  <DummyProcess4Xi(Thread-4, stopped 2812)>
        # KB2DUMMY[ 4 ]:  <DummyProcess4Xi(Thread-5, stopped 5040)>
        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 11/33) - COMMAND & CONTROL BEFORE RESULTS - OK
    # ---------------------------------------------------------------------------------------------   
    print("\n(STEP 11/33) OF TEST4 - COMMAND & CONTROL BEFORE RESULTS ", time4xi())    
     
    print("\n(STEP 11A/33) OF TEST4 - PREPARING TO RECEIVE ROGER MESSAGES ", time4xi())     
    # 02:23:54 02/26/13 Pacific Standard Time
        
    kb2roger = {}
    for key2mission in range(NUMBER_OF_PROCESSES+1):
        kb2roger[key2mission] = None
    
    print("\n(STEP 11B/33) OF TEST4 - STARTING TO RECEIVE ROGER MESSAGES ", time4xi())   
    
    for key2mission in range(NUMBER_OF_PROCESSES+1):
        print("(STEP 11C/33) OF TEST4 - KB2CONSUMER4CHANNEL[", key2mission, "] RECEIVE CHANNEL: ", kb2consumer4channel[key2mission].recv)
        # KB2CONSUMER4CHANNEL[ 0 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1400>>
        # KB2CONSUMER4CHANNEL[ 1 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1780>>
        # KB2CONSUMER4CHANNEL[ 2 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1748>>
        # KB2CONSUMER4CHANNEL[ 3 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1630>>
        # KB2CONSUMER4CHANNEL[ 4 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1668>>
        try:
            
            kb2roger[key2mission] = kb2consumer4channel[key2mission].recv()
            # 
            print("(STEP 11D/33) OF TEST4 - KB2ROGER[", key2mission, "]:", kb2roger[key2mission])
            # KB2ROGER[ 0 ]: <roger4xi>0</roger4xi>
            # KB2ROGER[ 1 ]: <roger4xi>1</roger4xi>
            # KB2ROGER[ 2 ]: <roger4xi>2</roger4xi>
            # KB2ROGER[ 3 ]: <roger4xi>3</roger4xi>
            # KB2ROGER[ 4 ]: <roger4xi>4</roger4xi>
        except:
            print("\n(STEP 11Z1/33) OF TEST4 *** FAILED TO RECEICE - KEY2MISSION: ", key2mission)    
                
    # -------------------------------------------------------------------------------------------------    
    # (STEP 11/33) - GET FIRST RESULTS FROM THOSE WITH WHOM COMMAND & CONTROL HAS BEEN ESTABLISHED - OK
    # -------------------------------------------------------------------------------------------------   
    print("\n(STEP 11E/33) OF TEST4 - TRYING TO GET FIRST RESULTS ", time4xi())     
    # 06:26:49 02/27/13 Pacific Standard Time
    kb2result1 = {}
    for key2mission in range(NUMBER_OF_PROCESSES+1):
        kb2result1[key2mission] = {}
    
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            if kb2roger[key2mission] is None:
                print("\n(STEP 11Z2/33) OF TEST4 *** FAILED TO ESTABLISH COMMAND & CONTROL - SKIPPED GETTING RESULTS FROM KEY2MISSION: ", key2mission) 
                # 
            else:
                for key2task in range(len(kb2task1)):    
                    kb2result1[key2mission] [key2task] = kb2queue4done[key2mission].get()
                    print("\n(STEP 11F/33) OF TEST4 - KB2RESULT1[", key2mission, "]", "[", key2task, "]: ", kb2result1[key2mission] [key2task])
                    # KB2RESULT1[ 0 ] [ 0 ]:  0
                    # KB2RESULT1[ 0 ] [ 1 ]:  7
                    # KB2RESULT1[ 0 ] [ 2 ]:  14
                    # KB2RESULT1[ 0 ] [ 3 ]:  21
                    # KB2RESULT1[ 0 ] [ 4 ]:  28
                    #
                    # KB2RESULT1[ 1 ] [ 0 ]:  0
                    # ...
                    # KB2RESULT1[ 1 ] [ 4 ]:  28
                    # ...
                    # KB2RESULT1[ 2 ] [ 0 ]:  0
                    # ...
                    # KB2RESULT1[ 2 ] [ 4 ]:  28
                    # 
                    # KB2RESULT1[ 3 ] [ 0 ]:  0
                    # ...
                    # KB2RESULT1[ 3 ] [ 4 ]:  28
                    #
                    # KB2RESULT1[ 4 ] [ 0 ]:  0
                    # ...
                    # KB2RESULT1[ 4 ] [ 4 ]:  28
    except:
        print("\n(STEP 11Z3/33) *** FAILED TO GET FIRST RESULTS ", time4xi())  
        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 12/33) - PUT MORE TASKS TO THOSE WITH WHOM COMMAND & CONTROL HAS BEEN ESTABLISHED - OK
    # --------------------------------------------------------------------------------------------- 
    print("\n(STEP 12A/33) OF TEST4 - TRYING TO PUT MORE TASKS  ", time4xi())  
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            if kb2roger[key2mission] is None:
                print("\n(STEP 12Z1/33) *** FAILED TO ESTABLISH COMMAND & CONTROL - SKIPPED PUTTING NEW TASKS TO KEY2MISSION: ", key2mission) 
            else:    
                kb2queue4task[key2mission].put(kb2task2[key2mission])
            
                print("\n(STEP 12B/33) OF TEST4 - PUT TASK: ", kb2task2[key2mission], " TO QUEUE; ", kb2queue4task[key2mission])
                # [(<function add at 0x0000000003903C80>, (0, 0)), (<function add at 0x0000000003903C80>, (1, 0)), (<function add at 0x0000000003903C80> ...
    except:
        print("\n(STEP 12Z2/33) OF TEST4 *** FAILED TO PUT MORE TASKS  ", time4xi())               
    
 
    # ---------------------------------------------------------------------------------------------    
    # (STEP 13/33) - PUT STOP TO THOSE WITH WHOM COMMAND & CONTROL HAS BEEN ESTABLISHED - OK 
    # --------------------------------------------------------------------------------------------- 
    print("\n(STEP 13/33) OF TEST4 - TRYING TO PUT STOP ", time4xi())  
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            if kb2roger[key2mission] is None:
                print("\n(STEP 13Z1/33) *** FAILED TO ESTABLISH COMMAND & CONTROL - SKIPPED PUTTING STOP FOR KEY2MISSION: ", key2mission) 
            else:  
                kb2queue4task[key2mission].put('STOP')
            
                print("\n(STEP 13A/33) OF TEST4 - PUT STOP QUEUE; ", kb2queue4task[key2mission])
                # <queue4xi.Queue4Xi object at 0x0000000002B722E8> ... 
    except:
        print("\n(STEP 13Z2/33) OF TEST4 *** FAILED TO PUT STOP ", time4xi())        

                  
    # -----------------------------------------------------------------------------------------------    
    # (STEP 14/33) - GET NEW RESULTS FROM THOSE WITH WHOM COMMAND & CONTROL HAS BEEN ESTABLISHED - OK
    # -----------------------------------------------------------------------------------------------             
    print("\n(STEP 14/33) OF TEST4 - TRYING TO GET NEW RESULTS ", time4xi())
    # 06:35:34 02/27/13 Pacific Standard Time
       
    kb2result2 = {}
    for key2mission in range(NUMBER_OF_PROCESSES+1):
        kb2result2[key2mission] = {}
        
    try:
        for key2mission in range(NUMBER_OF_PROCESSES+1):
            if kb2roger[key2mission] is None:
                print("\n(STEP 14Z1/33) *** FAILED TO ESTABLISH COMMAND & CONTROL - SKIPPED GETTING NEW RESULTS FROM KEY2MISSION: ", key2mission) 
            else:
                for key2task in range(len(kb2task2)):
                    kb2result2[key2mission] [key2task] = kb2queue4done[key2mission].get()
                    
                    print("\n(STEP 14A/33) OF TEST4 - KB2RESULT2[", key2mission, "]", "[", key2task, "]: ", kb2result2[key2mission] [key2task])
                    # KB2RESULT2[ 0 ] [ 0 ]:  35
                    # KB2RESULT2[ 0 ] [ 1 ]:  42
                    # KB2RESULT2[ 0 ] [ 2 ]:  49
                    # KB2RESULT2[ 0 ] [ 3 ]:  56
                    # KB2RESULT2[ 0 ] [ 4 ]:  63
                    # 
                    # KB2RESULT2[ 1 ] [ 0 ]:  35
                    # ...
                    # KB2RESULT2[ 1 ] [ 4 ]:  63
                    #
                    # KB2RESULT2[ 2 ] [ 0 ]:  35
                    # ...
                    # KB2RESULT2[ 2 ] [ 4 ]:  63
                    #
                    # KB2RESULT2[ 3 ] [ 0 ]:  35
                    # ...
                    # KB2RESULT2[ 3 ] [ 4 ]:  63
                    #
                    # KB2RESULT2[ 4 ] [ 0 ]:  35
                    # ...
                    # KB2RESULT2[ 4 ] [ 4 ]:  63
    except:
        print("\n(STEP 14Z2/33) *** FAILED TO GET NEW RESULTS ", time4xi())  

                  
    # ---------------------------------------------------------------------------------------------    
    # (STEP 15/33) - RECEIVE COMMAND & CONTROL MESSAGE THAT STOP GOT FROM QUEUE - OK
    # ---------------------------------------------------------------------------------------------             
    print("\n(STEP 14/33) OF TEST4 - TRYING TO RECEIVE COMMAND & CONTROL MESSAGE THAT STOP GOT FROM QUEUE ", time4xi())
    # 04:57:59 02/27/13 Pacific Standard Time 
    kb2stop = {}
    for key2mission in range(NUMBER_OF_PROCESSES+1):
        print("(STEP 14A/33) OF TEST4 - KB2CONSUMER4CHANNEL[", key2mission, "] RECEIVE CHANNEL: ", kb2consumer4channel[key2mission].recv)
        # KB2CONSUMER4CHANNEL[ 0 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1400>>
        # KB2CONSUMER4CHANNEL[ 1 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1780>>
        # KB2CONSUMER4CHANNEL[ 2 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1748>>
        # KB2CONSUMER4CHANNEL[ 3 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1630>>
        # KB2CONSUMER4CHANNEL[ 4 ] RECEIVE CHANNEL:  <bound method PipeConnection4Xi.recv of <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037C1668>>
        try:
            kb2stop[key2mission] = kb2consumer4channel[key2mission].recv()
            # 
            print("(STEP 14B/33) OF TEST4 - KB2ROGER[", key2mission, "]:", kb2stop[key2mission])
            # KB2ROGER[ 0 ]: <stop4xi>0</stop4xi>
            # KB2ROGER[ 1 ]: <stop4xi>1</stop4xi>
            # KB2ROGER[ 2 ]: <stop4xi>2</stop4xi>
            # KB2ROGER[ 3 ]: <stop4xi>3</stop4xi>
            # KB2ROGER[ 4 ]: <stop4xi>4</stop4xi>
        except:
            print("\n(STEP 14Z1/33) OF TEST4 *** FAILED TO RECEICE - KEY2MISSION: ", key2mission)    
                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 16/33) - JOIN PROCESSES - TO BE AVOIDED - OK
    # ---------------------------------------------------------------------------------------------     
    ack2join = False  # BIG RISK because this test just DIES if threads don't finish their job
                      # HIGHLY recommended to avoid join and istead take care with command & control everyhting!
    
    if ((ack2dummy is True) or (ack2join is False)):
        print("\n(STEP 16A/33) OF TEST4 - SKIPPED JOINING PROCESSES, ACK2DUMMY: ", ack2dummy, " ACK2JOIN: ", ack2join)
        # SKIPPED JOINING DUMMY PROCESSES, ACK2DUMMY:  False  ACK2JOIN:  False
    else:         
        print("\n(STEP 16B/33) OF TEST4 - JOINING PROCESSES ", time4xi())   
        # 06:19:52 02/26/13 Pacific Standard Time
        try:
            for key2mission in range(NUMBER_OF_PROCESSES+1):
                kb2process[key2mission].join()
                
                print("\n(STEP 16C/33) OF TEST4 - JOINED PROCESS : ", kb2process[key2mission])
                # 06:19:52 02/26/13 Pacific Standard Time 
        except:
            print("\n(STEP 16Z/33) OF TEST4 *** FAILED TO JOIN PROCESSES ", time4xi())
                

                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 17/33) - TERMINATE PROCESSES - OK
    # ---------------------------------------------------------------------------------------------     
    if ack2dummy is True:
        print("\n(STEP 17A/33) OF TEST4 - SKIPPED TERMINATING DUMMY PROCESSES ", time4xi())
        # 
    else:    
        print("\n(STEP 17B/33) OF TEST4 - TERMINATING PROCESSES ", time4xi())  
        # 06:19:52 02/26/13 Pacific Standard Time
        try:
            for key2mission in range(NUMBER_OF_PROCESSES+1):
                kb2process[key2mission].terminate()
                # <Process4Xi(Process4Xi-1, stopped)>
                # <Process4Xi(Process4Xi-2, stopped)>
                # <Process4Xi(Process4Xi-3, stopped)>
                # <Process4Xi(Process4Xi-4, stopped)>
                print("\n(STEP 17C/33) OF TEST4 - TERMINATED PROCESS : ", kb2process[key2mission])
                # 06:19:52 02/26/13 Pacific Standard Time
        except:
            print("\n(STEP 17Z/33) OF TEST4 *** FAILED TO TERMINATE ", time4xi())
                        

                                        
    # ---------------------------------------------------------------------------------------------    
    # (STEP 18/33) - DONE - OK 
    # ---------------------------------------------------------------------------------------------                  
    print("\n(STEP 18/33) OF TEST4 - DONE ", time4xi())  
    # 06:52:55 02/27/13 Pacific Standard Time
         
#</function4xi>               
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main of hello_world4xi
#">                               
# -------------------------------------------------------------------------------------------------           
def main(argv=None):
    global t2xi
    
    # ---------------------------------------------------------------------------------------------    
    # ORIGINAL MULTIPROCESSING
    # --------------------------------------------------------------------------------------------- 
    ack2test1 = False
    if ack2test1 is True:                
        print('=' *33)
        print("SENSING MATH WITH ORIGINAL MULTIPROCESSING ",time4xi())  
        print('=' *33)
        
        multiprocessing.freeze_support()
          
        test1() 
    
        print('=' *33)
        print("SENSED MATH WITH ORIGINAL MULTIPROCESSING ",time4xi())  
        print('=' *33)    
    else:
        print("SKIPPED SENSING MATH WITH ORIGINAL MULTIPROCESSING ",time4xi()) 
            
    # ---------------------------------------------------------------------------------------------    
    # HYBRID MULTIPROCESSING
    # --------------------------------------------------------------------------------------------- 
    ack2test2 = False
    if ack2test2 is True:                   
        print('=' *33)
        print("SENSING MATH WITH HYBRID MULTIPROCESSING ",time4xi())  
        print('=' *33)
        
        test2()
    
        print('=' *33)
        print("SENSED MATH WITH HYBRID MULTIPROCESSING ",time4xi())  
        print('=' *33)
    else:
        print("SKIPPED SENSING MATH WITH HYBRID MULTIPROCESSING ",time4xi())
            
    # ---------------------------------------------------------------------------------------------    
    # DRAGON4XI MULTIPROCESSING
    # --------------------------------------------------------------------------------------------- 
    ack2test4 = True
    if ack2test4 is True:
                              
        print('=' *33)
        print("SENSING MATH WITH DRAGONIZED MULTIPROCESSING4XI ",time4xi())  
        print('=' *33)
            
        global t2xi
        global trace_object_count    
              
        # --------------------------------------------------------------------------------------------- 
        # INITIALIZE TRACE
        # ---------------------------------------------------------------------------------------------        
        t2xi = Print4Xi()
        print("(STEP 0/33) OF TEST_MATH_MP_XI4 - SET T2XI TO: ", t2xi)
        # 
        set2trace4xi()                                                                                               # trace all classes and functions in the system
        deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
        tailor2trace4xi()                                                                                            # tailor trace for this test   
        
    
        # ---------------------------------------------------------------------------------------------------------
        # ALL TRIALS OF TESTS                          
        # ---------------------------------------------------------------------------------------------------------    
        try:    
            test4()
            
            print('=' *33)
            print("SENSED MATH WITH DRAGONIZED MULTIPROCESSING4XI ",time4xi())  
            # 06:52:55 02/27/13 Pacific Standard Time
            print('=' *33)
        except:
            print('=' *33)
            print("*** FAILED TO SENSE MATH WITH DRAGONIZED MULTIPROCESSING4XI ",time4xi())  
            print('=' *33)    
        finally:   
            # ---------------------------------------------------------------------------------------------    
            # Print Trace
            # --------------------------------------------------------------------------------------------- 
                
            print_trace4xi(t2xi) 
                
    else:
        print("SKIPPED SENSING MATH WITH DRAGONIZED MULTIPROCESSING4XI ",time4xi()) 
                                  
    print('=' *33)
    print("COMPLETED TEST_MATH_MP_XI4 ",time4xi())
    # 06:52:56 02/27/13 Pacific Standard Time  
    print('=' *33)
#</function4xi>
            
# -------------------------------------------------------------------------------------------------
#
# ------------------------------------------------------------------------------------------------- 
if __name__ == '__main__':
    
    main()

  

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_math4xi.txt
#   sense-math4xi.xml
#   reason-math4xi.xml
#   ace-math4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_math_mp_xi4.py                            
# ------------------------------------------------------------------------------------------------- 
